debug off
include <system.dh>
include <windows.dh>
include <LookUp2DInc.dh>

const M_PI2 6.2831853071795864
const deg20 0.6981317007977318

const red 0xFF
const magenta 0xFF00FF
const green 0xFF00
const blue 0xFF0000
const yellow 0xFFFF
const black 0
const white 0xFFFFFF
const trafsignblue 0xFF2020

const AT_ONEWAY 1704
//const AT_ENTEXI 1714
const AT_LABELS 17501
const AT_CATCAP 17532
const AT_FNTHEI 1661
const AT_NUMBER 60040

//const strcntr2 "#rffff00"
//const strcntr3 "#rffffff"
const street10 "#rffd700 w180"
const street12 "##rffd700 w180 *#rffff00"
const street13 "##rffd700 w180 *#rffffff"
const street20 "#rffd700 w150"
const street22 "##rffd700 w150 *#rffff00"
const street23 "##rffd700 w150 *#rffffff"
const street30 "#rffd700 w120"
const street32 "##rffd700 w120 *#rffff00"
const street33 "##rffd700 w120 *#rffffff"
const street40 "#rffd700 w90"
const street42 "##rffd700 w90 *#rffff00"
const street43 "##rffd700 w90 *#rffffff"
const strminor "#rffd700 w60"
const strkad "##rffd700 w180 *#rffffff#r808080 y90#r808080 y-90"
//const oneway_f "#fS52-5:12 r00ff00 z1.5 y200 dx500 s108"
//const oneway_b "#fS52-5:12 r00ff00 z1.5 y-200 dx500 s109"

local drawEdge(ch,eg)
{
  sz=chGetEdgeXY(ch,eg,0,x,y);
  Map2Win(x,y,x,y);
  MoveTo(x,y);
  for( i=1; i<sz; i+=1 )
  {
    sz=chGetEdgeXY(ch,eg,i,x,y);
    Map2Win(x,y,x,y);
    LineTo(x,y);
  }
}

local drawSelLine(ch,fe,rgb)
{
  prpen=SelectObject(CreatePen(PS_SOLID,3,rgb));
  sz=chGetFeatureLine(ch,fe,1,eg,flag);
  drawEdge(ch,eg);
  for( i=2; i<=sz; i+=1 )
  {
    chGetFeatureLine(ch,fe,i,eg,flag);
    drawEdge(ch,eg);
  }
  DeleteObject(SelectObject(prpen));
}

local drawNoTurn(orient,x,y,s1,s2,s3,rgb)
{
  if( !(fnt=CreateFont(-24,0,orient,orient,
      FW_DONTCARE,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,
      CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"S52-6")) )
    return;
  SetTextAlign(TA_LEFT|TA_BASELINE);
  SetBkMode(TRANSPARENT);
  prfnt=SelectObject(fnt);
  SetTextColor(yellow);
  SymbolOut(x,y,s3);
  if( rgb >= 0 )
  {
    SetTextColor(rgb);
    SymbolOut(x,y,s1);
  }
  else
  {
    SetTextColor(black);
    SymbolOut(x,y,s1);
    SetTextColor(red);
  }
  SymbolOut(x,y,s2);
  DeleteObject(SelectObject(prfnt));
}

global noturn(ch,fe,rgb)
{
  num=chGetFeatureLine(ch,fe,0,eg,flag);
  if( num != 2 )
    drawSelLine(ch,fe,magenta);
  if( rgb >= 0 )
    drawSelLine(ch,fe,rgb);
  for( i=1; i<num; i+=1 )
  {
    chGetFeatureLine(ch,fe,i,eg,flag);
    sz=chGetEdgeXY(ch,eg,0,x2,y2);
    if( flag & M_REVERSE )
      chGetEdgeXY(ch,eg,1,x1,y1);
    else
    {
      chGetEdgeXY(ch,eg,sz-1,x2,y2);
      chGetEdgeXY(ch,eg,sz-2,x1,y1);
    }
    chGetFeatureLine(ch,fe,i+1,eg,flag);
    sz=chGetEdgeXY(ch,eg,1,x3,y3);
    if( flag & M_REVERSE )
    {
      chGetEdgeXY(ch,eg,sz-2,x3,y3);
      chGetEdgeXY(ch,eg,sz-1,x22,y22);
    }
    else
      chGetEdgeXY(ch,eg,0,x22,y22);
    if( x22 != x2 || y22 != y2 )
      continue;
    a1=atan2(y2-y1,x2-x1);
    a2=atan2(y3-y2,x3-x2);
    if( a2 > M_PI )
      da1=a2-M_PI2;
    else
      da1=a2;
    if( a1 > M_PI )
      da2=a1-M_PI2;
    else
      da2=a1;
    da=da1-da2;
    if( da > M_PI )
      da-=M_PI2;
    else if( da < (-M_PI) )
      da+=M_PI2;
    Map2Win(x1,y1,x1,y1);
    Map2Win(x2,y2,x2,y2);
    if( y1 == y2 && x2 == x1 )
      a=0;
    else
      a=atan2(y2-y1,x1-x2);
    orient=int(rad2deg(a)*10);
    x=int(x2);
    y=int(y2);
    if( da > deg20 )
      drawNoTurn(orient,x,y,108,109,110,rgb);
    else if( da < (-deg20) )
      drawNoTurn(orient,x,y,111,112,113,rgb);
    else if( da >= 0 )
      drawNoTurn(orient,x,y,114,109,110,rgb);
    else //if( da < 0 )
      drawNoTurn(orient,x,y,115,112,113,rgb);
  }
  return 0;
}

local drawOneWay(orient,x1,y1,x2,y2,rgb)
{
  Map2Win(x1,y1,x1,y1);
  Map2Win(x2,y2,x2,y2);
  if( y1 == y2 && x2 == x1 )
    a=0;
  else
    a=atan2(y2-y1,x1-x2);
  if( (orient=int(rad2deg(a)*10)) > 3600 )
    orient-=3600;
  x=int(x2);
  y=int(y2);
  if( !(fnt=CreateFont(-24,0,orient,orient,
      FW_DONTCARE,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,
      CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"S52-6")) )
    return;
  SetTextAlign(TA_LEFT|TA_BASELINE);
  SetBkMode(TRANSPARENT);
  prfnt=SelectObject(fnt);
  if( rgb < 0 )
    SetTextColor(blue);
  else
    SetTextColor(rgb);
  SymbolOut(x,y,120);
  SetTextColor(white);
  SymbolOut(x,y,121);
  DeleteObject(SelectObject(prfnt));
}

local tooShort(val)
{
  if( val < 0 )
  {
    if( val > (-30) )
      return 1;
  }
  else if( val < 30 )
    return 1;
  return 0;  
}

local drawOneWay2(orient,_x1,_y1,_x2,_y2,rgb)
{
  Map2Win(_x1,_y1,x1,y1);
  Map2Win(_x2,_y2,x2,y2);
  if( tooShort(x2-x1) && tooShort(y2-y1) )
    return;
  a=atan2(y2-y1,x1-x2);
  if( (orient=int(rad2deg(a)*10)) > 3600 )
    orient-=3600;
  x=int((x1+x2)/2);
  y=int((y1+y2)/2);
  SetBkMode(TRANSPARENT);
  SetTextAlign(TA_RIGHT|TA_BASELINE);
  if( !(fnt=CreateFont(-14,0,orient,orient,FW_DONTCARE,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"S52-6")) )
    return;
  prfnt=SelectObject(fnt);
  if( rgb < 0 )
    SetTextColor(blue);
  else
    SetTextColor(rgb);
  SymbolOut(x,y,120);
  SetTextColor(white);
  SymbolOut(x,y,121);
  DeleteObject(SelectObject(prfnt));
}

local draw_oneway_frwd(ch,fe,rgb)
{
  num=chGetFeatureLine(ch,fe,0,eg,flag);
  for( i=1; i<=num; i+=1 )
  {
    chGetFeatureLine(ch,fe,i,eg,flag);
    if( flag & M_REVERSE )
    {
      n=chGetEdgeXY(ch,eg,0,x1,y1);
      for( chGetEdgeXY(ch,eg,n-=1,x1,y1); n>0; )
      {
        chGetEdgeXY(ch,eg,n-=1,x2,y2);
        drawOneWay2(orient,x2,y2,x1,y1,rgb);
        x1=x2;
        y1=y2;
      } 
    }
    else
    {
      n=chGetEdgeXY(ch,eg,0,x1,y1);
      for( j=1; j<n; j+=1 )
      {
        chGetEdgeXY(ch,eg,j,x2,y2);
        drawOneWay2(orient,x2,y2,x1,y1,rgb);
        x1=x2;
        y1=y2;
      }
    }
  }
}

local draw_oneway_bkwd(ch,fe,rgb)
{
  num=chGetFeatureLine(ch,fe,0,eg,flag);
  for( i=1; i<=num; i+=1 )
  {
    chGetFeatureLine(ch,fe,i,eg,flag);
    if( flag & M_REVERSE )
    {
      n=chGetEdgeXY(ch,eg,0,x1,y1);
      for( chGetEdgeXY(ch,eg,n-=1,x1,y1); n>0; )
      {
        chGetEdgeXY(ch,eg,n-=1,x2,y2);
        drawOneWay2(orient,x1,y1,x2,y2,rgb);
        x1=x2;
        y1=y2;
      } 
    }
    else
    {
      n=chGetEdgeXY(ch,eg,0,x1,y1);
      for( j=1; j<n; j+=1 )
      {
        chGetEdgeXY(ch,eg,j,x2,y2);
        drawOneWay2(orient,x1,y1,x2,y2,rgb);
        x1=x2;
        y1=y2;
      }
    }
  }
}
  
global oneway(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,AT_LAYERS,layer) || layer < 2 )
    return 1;
  if( layer == 2 )
    draw_oneway_frwd(ch,fe,rgb);
  else if( layer == 3 )
    draw_oneway_bkwd(ch,fe,rgb);
  return 1;
}

global street(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,AT_PATOFF,patoff) ||
      !chGetAttrValue(ch,fe,AT_LAYERS,layer) )
    return 0;
  if( patoff == 10 )
    s=street10;
  else if( patoff == 12 )
    s=street12;
  else if( patoff == 13 )
    s=street13;
  else if( patoff == 20 )
    s=street20;
  else if( patoff == 22 )
    s=street22;
  else if( patoff == 23 )
    s=street23;
  else if( patoff == 30 )
    s=street30;
  else if( patoff == 32 )
    s=street32;
  else if( patoff == 33 )
    s=street33;
  else if( patoff == 40 )
    s=street40;
  else if( patoff == 42 )
    s=street42;
  else if( patoff == 43 )
    s=street43;
  else if( patoff == 14 )
    s=strkad;
  else
    s=strminor;
  if( chGetAttrValue(ch,fe,SORIND,sorind) && sorind == "" )
  {
    if( layer == 2 )
      return "#"+s+"#fS52-5:12 rffd700 z1.5 y200 dx500 s108#r0000ff y-110#r0000ff y110";
    if( layer == 3 )
      return "#"+s+"#fS52-5:12 rffd700 z1.5 y-200 dx500 s109#r0000ff y-110#r0000ff y110";
    s="#"+s+"#r0000ff y110#r0000ff y-110";
  }
  else if( layer == 2 )
    return "#"+s+"#fS52-5:12 rffd700 z1.5 y200 dx500 s108";
  if( layer == 3 )
    return "#"+s+"#fS52-5:12 rffd700 z1.5 y-200 dx500 s109";
  return s;
}

global ADMDST_line(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,60910,catdst) )
    return 1;
  if( catdst == 11 ) // State reserve
    return "#r00AA00 w80 $patndx=40";
  return 1;
}    

global ADMDST_area(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,60910,catdst) )
    return 0;
  if( catdst == 12 ) // Hamlet
    return "#rB5C4B5 $patndx=38";
  if( catdst == 15 ) // City
    return "#rF4EFEC $patndx=34";
  if( catdst == 16 ) // Town
    return "#rF4EFEC $patndx=35";
  if( catdst == 17 ) // Town type
    return "#rEDE4D5 $patndx=36";
  if( catdst == 18 ) // Rural type
    return "#rE2DED7 $patndx=37";
  if( catdst == 19 ) // Suburban
    return "#rEDE4D5 $patndx=39";
  if( catdst == 20 ) // Green vegetation zone
    //return "#rCEECA8 $patndx=41";
    return "#rCEECA8 $patndx=6";
  return "#rEDE4D5 $patndx=33";  
}

global BLOCKS_area(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,60710,catblk) )
    return 0;
  if( catblk == 1 ) // Residential area
    return "#rF1EEE8 $patndx=50";
  if( catblk == 2 ) // University/College
    return "#rF8D6AF $patndx=51"; 
  if( catblk == 3 ) // Shopping center
    return "#rEFE0DA $patndx=52"; 
  if( catblk == 4 ) // Historical buildings
    return "#rF2CAEA $patndx=53";
  if( catblk == 5 ) // Summer camp
    return "#rCCFFFF $patndx=54";  
  if( catblk == 6 ) // Industrial territory
    return "#rdfd3d1 $patndx=55";  
  if( catblk == 7 ) // Military base
    return "#rF2EFE9 $patndx=56";
  if( catblk == 8 ) // Construction
    return "#rB6B690 $patndx=57";
  if( catblk == 9 ) //  Sports complex
    return "#rECE2A8 $patndx=58";
  if( catblk == 10 ) // Parking lot
    return "#rF1E9BD $patndx=59";
  if( catblk == 11 ) // Hospital
    return "#rF7D2CA $patndx=60";
  if( catblk == 12 ) // Commercial
    return "#rF0C8C7 $patndx=61";
  if( catblk == 13 ) // Waste ground
    return "#rB6B690 $patndx=62";
  if( catblk == 14 ) // Brownfield
    return "#rB6B690 $patndx=63";
  if( catblk == 15 ) // Garages
    return "#rDEDDCC $patndx=64";
  if( catblk == 16 ) // Railway zone
    return "#rDED0D5 $patndx=65";
  return 0;    
}

global BUILDS_area2(ch,fe,rgb)
{
  if( chGetAttrText(ch,fe,17523,facpic) && chGetFeatureArea(ch,fe,1,1,eg,flag) )
  {
    chSetGeoUnits(0);  
    if( flag & M_REVERSE )
    {
      sz=chGetEdgeXY(ch,eg,0,x1,y1);
      chGetEdgeXY(ch,eg,sz-1,x1,y1);
      chGetEdgeXY(ch,eg,sz-2,x2,y2);
      //puts(facpic+" <- "+eg+" "+x1+":"+y1);
    }
    else
    {
      chGetEdgeXY(ch,eg,0,x1,y1);
      chGetEdgeXY(ch,eg,1,x2,y2);
      //puts(facpic+" -> "+eg+" "+x1+":"+y1);
    }
    if( chMap2Win(ch,x1,y1,x1,y1) && chMap2Win(ch,x2,y2,x2,y2) && ( fabs(x2-x1) > 7 || fabs(y2-y1) > 7 ) )
    {
      x1=int(x1+0.5);
      y1=int(y1+0.5);
      x2=int(x2+0.5);
      y2=int(y2+0.5);
      pen=CreatePen(PS_SOLID,7,0xFF00FF);
      prpen=SelectObject(pen);
      MoveTo(x1,y1);
      LineTo(x2,y2);
      SelectObject(prpen);
      DeleteObject(pen);
    }
  }
}

global BUILDS_area(ch,fe,rgb)
{
  if( chGetAttrText(ch,fe,60190,bldfnc) )
  {
    if( bldfnc == "1" ) // Inhabited building  0x006C
      return "#rC3A492 $patndx=67 $facclr=D6C1B6";
    if( bldfnc == "3" ) // Industrial 
      return "#r9d9d9d $patndx=69 $facclr=898989";
    if( bldfnc == "4" ) // Office
      return "#r4d716b $patndx=70  $facclr=86ADA4";
    if( bldfnc == "10" ) // Civilian registry office
      return "#r729CB7 $patndx=76 $facclr=99B7CA";
    if( bldfnc == "21" ) // Garage 
      return "#rDDCDB1 $patndx=87 $facclr=E8DDCA";
    if( bldfnc == "23" ) // Historical 
      return "#rCC9999 $patndx=89 $facclr=DDBBBB";
    if( bldfnc == "24" ) // Hospital
      return "#rb66761 $patndx=90 $facclr=e58f8a";
    if( bldfnc == "25" ) // Hotel
      return "#rCB98FF $patndx=91 $facclr=CB98FF";
    if( bldfnc == "32" ) // Market
      return "#rBB8CAF $patndx=98 $facclr=D7BCD0";
    if( bldfnc == "39" ) // Polyclinic
      return "#rF5A29D $patndx=105 $facclr=F8C1BD";
    if( bldfnc == "45" ) // School
      return "#r6D97B1 $patndx=111 $facclr=A3BDCE";
    if( bldfnc == "48" ) // Shop 
      return "#rBB8CAF $patndx=114 $facclr=D7BCD0";
    if( bldfnc == "50" ) // Sport 
      return "#rCDC6A7 $patndx=116 $facclr=DED9C5";
    if( bldfnc == "51" ) // Stadium
      return "#r8AD3AF $patndx=117 $facclr=C6E9D8";
    if( bldfnc == "55" ) // Supermarket
      return "#rCDC6A7 $patndx=121 $facclr=DED9C5";
    if( bldfnc == "62" ) // Other
      return "#r8B8970 $patndx=128 $facclr=B1B09F";
    if( bldfnc == "66" ) // Passenger terminal
      return "#rCB98FF $patndx=132 $facclr=CB98FF";
    if( bldfnc == "73" ) // Common public building
      return "#rE5B7D9 $patndx=139 $facclr=E5B7D9";
  }    
  return "#rC3A492 $patndx=66 $facclr=DCCABF";
}

/*global CEMTRY_area(ch,fe,rgb)
{
  if( !chGetAttrText(ch,fe,60020,nobnam) )
    return 1;
  if( nobnam == "2" ) // Mosque
    return "##rBDD7AD *#fS52-2:12 r575757 dx500 dy500 s46";
  if( nobnam == "1" ) // Christ
    return "##rbed6ad#fCityPlan01:12 r5c5c5c z0.3 dx800 dy800 s90";
  return 1;  
}*/

global LTBLDS_area(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,60250,catlbl) )
    return 0;
  if( catlbl == 32 ) // Garage  
    return "#rD3D3D3";  
  return 0;
}    

global SURFCE_area(ch,fe,rgb)
{
  if( !chGetAttrText(ch,fe,60225,natsur) )
    return 0;
  if( StrFind(natsur,"14") )    // ice  
    return "#rCEF0FC $patndx=149";
  if( StrFind(natsur,"15") )    // sand/mud   
    return "##rB8DEFE *#fS52-2:3 r7D3F00 dx150 dy150 s61 $patndx=150";
  if( StrFind(natsur,"4") )     // sand  
    return "##rFFF7E7 *#fS52-1:2 rD6CBB5 dx250 dy250 s61 $patndx=2";
  if( StrFind(natsur,"5") )     // stone  
    return "#rE2EFD8 $patndx=148";
  if( StrFind(natsur,"9") )     // rock
    return "#rE2EFD8 $patndx=151";
  return 0;  
}

global VEGCLT_area(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,60760,catclv) )
    return 1;
  if( catclv == 1 ) // Garden
    return "#rC8B084 $patndx=6";
  if( catclv == 2 ) // Vineyard
    return "#rC8B084 $patndx=175";
  if( catclv == 3 ) // National park
    return "#rB5CAA3 $patndx=176";
  if( catclv == 4 ) // City park
    return "#rABDF96 $patndx=177";
  if( catclv == 5 ) // Golf lawn
    return "#rB5E2B5 $patndx=174";
  if( catclv == 6 ) // Orchard
    return "#rC8B084 $patndx=175";
  if( catclv == 7 ) // Farmland
    return "#rECDDC8 $patndx=176";
  return 1;
}    

global VEGGRS_area(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,60740,catgrv) )
    return 1;
  if( catgrv == 1  ) // Lawn
    return "#rFFFFC0 $patndx=183";
  if( catgrv == 2  ) // Meadow
    return "#rCFECA8 $patndx=184";
  if( catgrv == 3  ) // Heath
    return "#rD6D99F $patndx=185";
  if( catgrv == 4  ) // Moor
    return "#rD6D99F $patndx=186";
  if( catgrv == 5  ) // Fell
    return "#rD6D99F $patndx=187";
  return 1;
}    

global VEGTRS_area(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,60770,cattrv) )
    return 1;
  if( cattrv == 7 ) // disafforestation
    return "##rffffff *#fS52-3:12 r000000 dx400 dy400 s85 $patndx=16";
  return 1;
}    

global VEGBRS_area(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,60750,catbrv) )
    return 1;
  if( catbrv == 1 ) // Plant nursery
    return "#rD4E8C6 $patndx=164"; //return "#rD4E8C6 $patndx=165";
  return 1;
}    

global AIRFCY_line(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,61310,catfcy) )
    return 1;
  if( catfcy == 9 ) // Railway platform
    return "#rBABABA w70 $patndx=209";
  return 1;
}    

global AIRFCY_area(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,61310,catfcy) )
    return 0;
  if( catfcy == 1 ) // Pitch
    return "#r89D2AE $patndx=201";
  if( catfcy == 2 ) // Playground
    return "#rCCFFF1 $patndx=202";
  if( catfcy == 3 ) // Dog park
    return "#rABDF96 $patndx=203"; // to set color
  if( catfcy == 4 ) // Dance place
    return "#rABDF96 $patndx=204"; // to set color
  if( catfcy == 5 ) // Bandstand
    return "#rABDF96 $patndx=205"; // to set color
  if( catfcy == 6 ) // Ice rink
    return "#rCEF0FC $patndx=206";
  if( catfcy == 7 ) // Recreation area
    return "#rECE2A8 $patndx=207";
  if( catfcy == 8 ) // Water park
    return "#rECE2A8 $patndx=208";
  if( catfcy == 9 ) // Railway platform
    return "#rBABABA $patndx=209";
  return 0;
}    

global BLDBND_line(ch,fe,rgb)
{
  if( !chGetAttrText(ch,fe,60190,bldfnc) )
    return 1;
  if( bldfnc == "1" ) // Inhabited building 
    //return "#rD8D0C9";
    return "#rCCC4BD";
  if( bldfnc == "3" ) // Industrial 
    return "#r777576";
  if( bldfnc == "4" ) // Office 
    return "#r639696";
  if( bldfnc == "10" ) // Common
    return "#r7D6F54";
  if( bldfnc == "21" ) // Garage 
    return "#rC4AA7A";
  if( bldfnc == "50" ) // Sport 
    return "#rB49456";
  if( bldfnc == "9" )  // Sport 
    return "#rCAB52E"; //#r52726A"
  return 1;  
}

global RIVERS_line_area(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,60720,stariv) )
    return 1;
  if( stariv == 1 ) // "Dry up site of a riverbed of the river or stream"
    return "#rD3E3E3 $patndx=22";
  return 1;  
}

global RUNWAY_line(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,61340,catrwy) )
    return 1;
  if( catrwy == 1 ) // runway
    return "#rBBBBCC w210 $patndx=22";
  if( catrwy == 2 ) // taxiway
    return "#rBBBBCC w70 $patndx=31";
  if( catrwy == 3 ) // apron
    return "#rE9D1FE w70 $patndx=32";
  if( catrwy == 4 ) // aerodrome
    return "#rE8E6E1 w70 $patndx=265";
  if( catrwy == 5 ) // helipad
    return "#rBBBBCC w210 $patndx=22";
  return 1;  
}

global RUNWAY_area(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,61340,catrwy) )
    return 1;
  if( catrwy == 1 ) // runway
    return "#rBBBBCC $patndx=22";
  if( catrwy == 2 ) // taxiway
    return "#rBBBBCC $patndx=31";
  if( catrwy == 3 ) // apron
    return "#rE9D1FE $patndx=32";
  if( catrwy == 4 ) // aerodrome
    return "#rE8E6E1 $patndx=265";
  if( catrwy == 5 ) // helipad
    return "#rBBBBCC $patndx=22";
  return 1;  
}

global RLFFRM_line_area(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,60260,catrlf) )
    return 0;
  if( catrlf == 7 )   // ditch
    return "#r7C7C3F w60 $patndx=234";
  if( catrlf == 13 )  // quarry
    return "#rC5C3C3 $patndx=235";
  if( catrlf == 15 )  // cliff
    return "#rC7C3C3 $patndx=236";
  return 0;  
}

global FENCEL_line(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,60290,catfen) )
    return 1;
  if( catfen == 1 )   // break wall
    return "#r505028 w60 $patndx=251";
  if( catfen == 2 )   // hard
    return "#r505028 w30 $patndx=252";
  if( catfen == 3 )   // easy
    return "#r808040 w10 $patndx=253";
  if( catfen == 4 )   // hedge
    return "#r007F00 w10 $patndx=254";
  return 1;  
}

global CABLNE_line(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,60505,catcab) )
    return 1;
  if( catcab == 1 )   // high voltage
    return "#r888482 w30 $patndx=258";
  if( catcab == 2 )   // low voltage
    return "#r888482 w10 $patndx=259";
  if( catcab == 3 )   // communication
    return "#r888482 $patndx=260";
  return 1;  
}

global TRNSPT_line(ch,fe,rgb)
{
  if( !chGetAttrText(ch,fe,60600,cattrn) )
    return 1;
  if( cattrn == "1" ) // "Trolleybus"
    return "#4D4D9C"; 
  if( cattrn == "2" ) //"Tram"
    return "#B23B00"; 
  if( cattrn == "3" ) // "Bus"
    return "#FFFF00"; 
  return 1;  
}

local StreetByNOBJNM(nobjnm)
{
  if( nobjnm == 10 ) //
    return "##r7f7f7f w160#rFCFA74 w120"; // oneway: "##r7f7f7f w100#rF5A555 w70"; 
  if( nobjnm == 13 ) //
    return "##r7f7f7f w220#rF5A555 w180#rffffe0";  
  if( nobjnm == 777 ) //
    return "##rF5A555 w100#r7f7f7f";  // w80#rffffe0
  if( nobjnm == 15 ) // x0049    
    return "##r7f7f7f w280#rF5A555 w240#rffffe0"; 
  if( nobjnm == 20 )        //   
    return "##r787878 w140#rffffe0 w100";  
  if( nobjnm == 30 )        //  
    return "##r787878 w140#rffffe0 w100";  
  if( nobjnm == 32 )        // 22?
    return "##rE9BE93 w120 *#r993333 w20 y60 #r993333 w20 y-60";  
  if( nobjnm == 35 )        //
    return "##r787878 w90#rd9d9d9 w60";  
  if( nobjnm == 40 )        //  
    return "##rB99C58 w100#rF0ECD3 w60"; //"##rB99C58 w150 #rF0ECD3w190" ;  //"##r787878 w80#rffffe0 w60"
  //if( nobjnm == 43 ) // --
  //  return 0;//"##r7f7f7f w80#rffffe0 w60";  
  if( nobjnm == 50 )        //  
    return "##rB99C58 w100#rF0ECD3 w60"; //"##rF0ECD3 w100#rB99C58 w10 y35 p500:200 n16#rB99C58 w10 y-35 p500:200 n16";
  //return "##r787878 w110#rF0ECD3 w70";  
  if( nobjnm == 60 )        // 
    return "##r787878 w100#rF0ECD3 w60";  
  if( nobjnm == 17 ) // 70?
    return "##r787878 w100#rd9d9d9 w70";  
  if( nobjnm == 77 ) // 
    return "##r787878 w140#rffffe0 w100";  
  if( nobjnm == 80 )        //  
    return "##rd9d9d9 w100 *#r0 w10 y50 p30:180 n16#r0 w10 y-50 p30:180 n16";  
  //if( nobjnm == 90 ) // ferry
  //  return "#r1e90ff w20 p300:100";  
  
  if( nobjnm == 14 )        // 
    return "##r787878 w180#rF5A555 w140#rffffe0";  
  if( nobjnm == 114 )       // 
    return "##r787878 w240#rF5A555 w200#rffffe0";  
  if( nobjnm == 9 )         //  
    return "#rB2BEB2 w140 p300:200";  
  if( nobjnm == 109 )       //  
    return "#rB2BEB2 w140 p300:200";  
  if( nobjnm == 220 )       //   
    return "##r787878 w180#rffffe0 w140";  
  if( nobjnm == 120 )       //   
    return "##r787878 w220#rffffe0 w180";  
  if( nobjnm == 2120 )      //   
    return "##r787878 w240#rF5A555 w200";  
  if( nobjnm == 21 )        //    
    return "##r669933 w240#rffffe0 w200";  
  if( nobjnm == 121 )       //    
    return "##r669933 w240#rffffe0 w200";  
  if( nobjnm == 2121 )      //    
    return "##r669933 w260#rF5A555 w220";  
  if( nobjnm == 23 )        //   
    return "##r787878 w240#rffffe0 w200#r787878";  
  if( nobjnm == 123 )       //   
    return "##r787878 w240#rffffe0 w200#r787878";  
  if( nobjnm == 223 )       //   
    return "##r787878 w260#rffffe0 w220#r787878";  
  if( nobjnm == 2123 )      //   
    return "##r787878 w260#rF5A555 w220#r787878";  
  if( nobjnm == 73 )        //   
    return "##r787878 w240#rffffe0 w200";  
  if( nobjnm == 173 )       //   
    return "##r787878 w240#rffffe0 w200";  
  if( nobjnm == 2173 )      //   
    return "##r787878 w260#rF5A555 w220";  
  if( nobjnm == 273 )       //   
    return "##r787878 w260#rF5A555 w220";  
  if( nobjnm == 24 )        //    
    return "##rd9d9d9 w180#r808080 w20 y90 p600:180 n16#r808080 w20 y-90 p600:180 n16";  
  if( nobjnm == 124 )       //    
    return "##rd9d9d9 w180#r808080 w20 y90 p600:180 n16#r808080 w20 y-90 p600:180 n16";  
  if( nobjnm == 230 )       //  
    return "##r787878 w210#rF5A555 w170";  
  if( nobjnm == 130 )       //  
    return "##r787878 w190#rffffe0 w150";  
  if( nobjnm == 2130 )      //  
    return "##r787878 w210#rF5A555 w170";  
  if( nobjnm == 31 )        //    
    return "##r669933 w200#rffffe0 w160";  
  if( nobjnm == 131 )       //    
    return "##r669933 w200#rffffe0 w160";  
  if( nobjnm == 2131 )      //    
    return "##r669933 w200#rF5A555 w160";  
  if( nobjnm == 74 )        //    
    return "##r787878 w210#rffffe0 w170";  
  if( nobjnm == 274 )       //    
    return "##r787878 w210#rF5A555 w170";  
  if( nobjnm == 2174 )      //    
    return "##r787878 w210#rF5A555 w170";  
  if( nobjnm == 140 )       //  
    return "##r787878 w130#rffffe0 w90";  
  if( nobjnm == 240 )       //  
    return "##r787878 w130#rF5A555 w90";  
  if( nobjnm == 2140 )      //  
    return "##r787878 w130#rF5A555 w90";  
  if( nobjnm == 42 )        //   ( ?)
    return "##r787878 w160#rffffe0 w120";  
  if( nobjnm == 142 )       //   ( ?)
    return "##r787878 w160#rffffe0 w120";  
  if( nobjnm == 242 )       //   ( ?)
    return "##r787878 w160#rF5A555 w120";  
  if( nobjnm == 2142 )      //   ( ?)
    return "##r787878 w160#rF5A555 w120";  
  if( nobjnm == 43 )        //  
    return "#rb2beb2 w120 p300:200";  
  if( nobjnm == 143 )       //  
    return "#rb2beb2 w120 p300:200";  
  if( nobjnm == 70 )        // 
    return "##r787878 w130#rd9d9d9 w90";  
  if( nobjnm == 170 )       // 
    return "##r787878 w130#rd9d9d9 w90";  
  if( nobjnm == 72 )        // 
    return "##r787878 w130#rf0ecd3 w90";  
  if( nobjnm == 172 )       // 
    return "##r787878 w130#rf0ecd3 w90";  
  if( nobjnm == 177 )       // 
    return "##r787878 w190#rffffe0 w150";  
  if( nobjnm == 2177 )      // 
    return "##r787878 w190#rF5A555 w150";  
  if( nobjnm == 277 )       // 
    return "##r787878 w190#rF5A555 w150";  
  if( nobjnm == 81 )        //  
    return "##rd9d9d9 w150#r0 w10 y75 p30:180 n16#r0 w10 y-75 p30:180 n16";  
  if( nobjnm == 95 )        // 
    return "##r787878 w190#rffffe0 w150";  
  if( nobjnm == 195 )       // 
    return "##r787878 w190#rffffe0 w150";  
  if( nobjnm == 2195 )      // 
    return "##r787878 w190#rF5A555 w150";  
  return 1;  
}

local StreetByROACLS(roacls,res)
{
  if( roacls == 1 )               // " "          
    res="##r7F7F7F w160#rFECC8B w100";
  else if( roacls == 2 )          // "" 
    res="##r7F7F7F w160#rF8F8BA w100";
  else if( roacls == 3 )          // "" 
    res="##r7F7F7F w100#rF4EDCD w70";
  else if( roacls == 4 )          // "" 
    res="##r7F7F7F w140#rFFFFFF w80";
  else if( roacls == 5 )          // " "         
    res="#rDFBDB2 w40";
  else if( roacls == 6 )          // " " 
    res="##r7F7F7F w130#rDEDBDE w70";
  else if( roacls == 7 )          // " " 
    res="##r7F7F7F w100#rD9DD72 w60";
  else if( roacls == 8 )          // "" 
    res="##r7F7F7F w110#rFFFFFF w50";
  else if( roacls == 9 )          // " " 
    res="##r7F7F7F w190#rFC9B60 w130";
  else if( roacls == 10 )         // " "              
    res="##r7F7F7F w180#rF8F8BA w120";
  else if( roacls == 11 )         // " " 
    res="##r7F7F7F w170#rF7F7DF w110";
  else if( roacls == 12 )         // "  "
    res="##rBD9E5A w100#rF7EFD6 w65";
  else if( roacls == 13 )         // "/ " 
    //res="##rEADEBB w80#rDCDCDC w50";
    res="#rBCBCBC w50";
  else if( roacls == 14 )         // " " 
    res="##rC6C6C6 w80#rFFFFFF w50";
  else if( roacls == 15 )         // " " 
    res="##r555555 w80#r888888 w50";
  else if( roacls == 16 )         // "" 
    res="##rCA5E18 w120#rFC9B60 w50";
  else if( roacls == 17 )         // "  "
    res="##r7F7F7F w140#rFFFF8A w100";
  else if( roacls == 18 )         // " "  
    res="##r7F7F7F w150#rE5A28A w100#r7F7F7F";
  else if( roacls == 19 )         // "  (OSM trunk)"  
    res="##rC9876C w150  #rFC9B60 w120"; 
  else if( roacls == 20 )         // "  (OSM primary)"  
    res="##r7F7F7F w150 #rFECC8B w100";
  else
    return 0;
  return 1; 
}

local NoTransStreetByROACLS(roacls,res)
{
  if( roacls == 1 )               // " "          
    res="##rFF0000 w200#rFECC8B w100";
  else if( roacls == 2 )          // "" 
    res="##rFF0000 w200#rF8F8BA w100";
  else if( roacls == 3 )          // "" 
    res="##rFF0000 w170#rF4EDCD w70";
  else if( roacls == 4 )          // "" 
    res="##rFF0000 w180#rFFFFFF w80";
  else if( roacls == 5 )          // " "         
    res="##rFF0000 w110#rDFBDB2 w40";
  else if( roacls == 6 )          // " " 
    res="##rFF0000 w170#rDEDBDE w70";
  else if( roacls == 7 )          // " " 
    res="##rFF0000 w160#rD9DD72 w60";
  else if( roacls == 8 )          // "" 
    res="##rFF0000 w150#rFFFFFF w50";
  else if( roacls == 9 )          // " " 
    res="##rFF0000 w230#rFC9B60 w130";
  else if( roacls == 10 )         // " "              
    res="##rFF0000 w220#rF8F8BA w120";
  else if( roacls == 11 )         // " " 
    res="##rFF0000 w210#rF7F7DF w110";
  else if( roacls == 12 )         // "  "
    res="##rFF0000 w160#rF7EFD6 w65";
  else if( roacls == 13 )         // "/ " 
    res="##rFF0000 w120#rDCDCDC w50";
  else if( roacls == 14 )         // " " 
    res="##rFF0000 w120#rFFFFFF w50";
  else if( roacls == 15 )         // " " 
    res="##rFF0000 w120#r888888 w50";
  else if( roacls == 16 )         // "" 
    res="##rCA5E18 w150#r #rFC9B60 w50";//res="##rCA5E18 w150#rFC9B60";
  else if( roacls == 17 )         // "  "
    res="##rFF0000 w200#rFFFF8A w100";
  else if( roacls == 18 )         // " "  
    res="##rFF0000 w200#rE5A28A w100#r7F7F7F";
  else if( roacls == 19 )         // "  (OSM trunk)"  
    res="##rFF0000 w200  #rFC9B60 w170";
  else if( roacls == 20 )         // "  (OSM primary)"  
    res="##rFF0000 w200 #rFECC8B w170";
  else
    return 0;
  return 1; 
}

local Speed0StreetByROACLS(roacls,res)
{
  if( roacls == 1 )               // " "          
    res="##rFF00FF w200#rFECC8B w100";
  else if( roacls == 2 )          // "" 
    res="##rFF00FF w200#rF8F8BA w100";
  else if( roacls == 3 )          // "" 
    res="##rFF00FF w170#rF4EDCD w70";
  else if( roacls == 4 )          // "" 
    res="##rFF00FF w180#rFFFFFF w80";
  else if( roacls == 5 )          // " "         
    res="##rFF00FF w110#rDFBDB2 w40";
  else if( roacls == 6 )          // " " 
    res="##rFF00FF w170#rDEDBDE w70";
  else if( roacls == 7 )          // " " 
    res="##rFF00FF w160#rD9DD72 w60";
  else if( roacls == 8 )          // "" 
    res="##rFF00FF w150#rFFFFFF w50";
  else if( roacls == 9 )          // " " 
    res="##rFF00FF w230#rFC9B60 w130";
  else if( roacls == 10 )         // " "              
    res="##rFF00FF w220#rF8F8BA w120";
  else if( roacls == 11 )         // " " 
    res="##rFF00FF w210#rF7F7DF w110";
  else if( roacls == 12 )         // "  "
    res="##rFF00FF w160#rF7EFD6 w65";
  else if( roacls == 13 )         // "/ " 
    res="##rFF00FF w120#rDCDCDC w50";
  else if( roacls == 14 )         // " " 
    res="##rFF00FF w120#rFFFFFF w50";
  else if( roacls == 15 )         // " " 
    res="##rFF00FF w120#r888888 w50";
  else if( roacls == 16 )         // "" 
    res="##rCA5E18 w150#r #rFC9B60 w50";//res="##rCA5E18 w150#rFC9B60";
  else if( roacls == 17 )         // "  "
    res="##rFF00FF w200#rFFFF8A w100";
  else if( roacls == 18 )         // " "  
    res="##rFF00FF w200#rE5A28A w100#r7F7F7F";
  else if( roacls == 19 )         // "  (OSM trunk)"  
    res="##rFF00FF w200  #rFC9B60 w170";
  else if( roacls == 20 )         // "  (OSM primary)"  
    res="##rFF00FF w200 #rFECC8B w170";
  else
    return 0;
  return 1; 
}

global STREET_line(ch,fe,rgb)
{
  if( chGetAttrValue(ch,fe,17508,roacls) )
  {
    if( /*GetCurScale() <= 50000 &&*/ chGetAttrText(ch,fe,17509,roarst) && StrSpanEx(roarst,";") == "1" && NoTransStreetByROACLS(roacls,res) )
      return res;
    if( chGetAttrValue(ch,fe,60407,mspeed) && mspeed == 0 && Speed0StreetByROACLS(roacls,res) )
      return res;
    if( StreetByROACLS(roacls,res) )
      return res;
  }  
  if( !chGetAttrText(ch,fe,301,nobjnm) )
    return 1;
  return StreetByNOBJNM(int(nobjnm));
}

global STREET_oneway(ch,fe,rgb)
{
  if( GetCurScale() > 25000 )
    return;
  if( !chGetAttrValue(ch,fe,AT_ONEWAY,oneway) )
    return;
  if( oneway == 1 )
    draw_oneway_frwd(ch,fe,rgb);
  else // if( oneway == 2 )
    draw_oneway_bkwd(ch,fe,rgb);
}

global BUILDS_pnt(ch,fe,rgb)
{
  if( !chGetAttrText(ch,fe,60190,bldfnc) )
  {
    if( !chGetAttrText(ch,fe,61068,poicat) )
      return 0;
    if( poicat == "amuspark" || poicat == "bowling" || poicat == "entertainment" )
      return "#fCityPlan01:12 s50 r8A5C8A z0.9"; 
    if( poicat == "atelier" || poicat == "beauty" || poicat == "laundry" || poicat == "photo" || 
        poicat == "repair" || poicat == "repaircomputer" || poicat == "repairdevice" || poicat == "repairfurniture" ||
        poicat == "repairshoes" || poicat == "service" || poicat == "tradefirm" || poicat == "xerox" )
      return "#fCityPlan01:12 s61 rDDA0DD z0.9";
    if( poicat == "ATM" || poicat == "bank" )
      return "#fCityPlan01:12 s117 r009240 z0.9"; 
    if( poicat == "autoclub" )
      return "#fCityPlan01:12 s108 rA0522D z0.9"; 
    if( poicat == "bar" || poicat == "casino" || poicat == "wine" )
      return "#fCityPlan01:12 s98 r4682B4 z0.9"; 
    if( poicat == "business" || poicat == "firm" || poicat == "insurance" ||
        poicat == "lawoffice" || poicat == "notary" || poicat == "realestate" || poicat == "travelagency" )
      return "#fCityPlan01:12 s118 r7F7F7F z0.9";
   if( poicat == "camping" )
      return "#fCityPlan01:12 s120 r8A8A8A z0.9"; 
    if( poicat == "carwash" )
      return "#fCityPlan01:12 s106 r8A8A8A z0.9"; 
    if( poicat == "circus" )
      return "#fCityPlan01:12 s52 r483D8B z0.9"; 
    if( poicat == "communication" )
      return "#fCityPlan01:12 s104 r7DA8FF z0.9"; 
    if( poicat == "court" )
      return "#fCityPlan01:12 s58 r8C8C27 z0.7"; 
    if( poicat == "custom" )
      return "#fCityPlan01:12 s100 r5C5C5C z0.9"; 
    if( poicat == "inetcafe" || poicat == "wifi" )
      return "#fCityPlan01:12 s121 r009240 z0.9"; 
    if( poicat == "information" )
      return "#fCityPlan01:12 s74 r6495ED z0.9"; 
    if( poicat == "kindergarden" ) 
      return "#fCityPlan01:12 s78 rFF7800 z0.9"; 
    if( poicat == "publisher" )
      return "#fCityPlan01:12 s67 rD889A7 z0.7";
    if( poicat == "repairboat" )
      return "#fCityPlan01:12 s79 r1E90FF z0.9";
    if( poicat == "sauna" || poicat == "shower" )
      return "#fCityPlan01:12 s39 r00BFFF z0.7";
    if( poicat == "ticket" )
      return "#fCityPlan01:12 s74 r7DA8FF z0.9";
    if( poicat == "utility" )
      return "#fCityPlan01:12 s57 r8B008B z0.9";
    if( poicat == "zoo" ) 
      return "#fCityPlan01:12 s52 rADA136 z0.9"; 
    return 0;
  }
  if( bldfnc == "2" ) // Airport 
    return "#fCityPlan01:12 s76 r7DA8FF z0.9";
  if( bldfnc == "4" ) // Building of public and state organizations 
    return "#fCityPlan01:12 s118 r7F7F7F z0.9";
  if( bldfnc == "5" ) // Bus station 
    return "#fCityPlan01:12 s63 r797AFF z0.9";
  if( bldfnc == "6" ) // Cafe 
    return "#fCityPlan01:12 s115 r4682B4 z0.9";
/*  if( bldfnc == "7" ) // Camping 
  {
    if( chGetAttrText(ch,fe,61068,poicat) && poicat == "camping" )
      return "#fCityPlan01:12 s118 r7F7F7F z0.9";
    return "#fCityPlan01:12 s120 r2E8B57 z0.9";
  }  */
  if( bldfnc == "8" ) // Church 
    return "#fCityPlan01:12 s53 rFF8686 z0.9";
  if( bldfnc == "9" ) // Cinema 
    return "#fCityPlan01:12 s71 rA52A2A z0.9";
  if( bldfnc == "12" ) // College 
    return "#fCityPlan01:12 s72 r2EB82E z0.9";
  if( bldfnc == "13" ) // Concert hall 
    return "#fCityPlan01:12 s52 r483D8B z0.9"; 
  if( bldfnc == "15" ) // Department store 
    return "#fCityPlan01:12 s122 rA0522D z0.9";
  if( bldfnc == "18" ) // Exhibition hall 
    return "#fCityPlan01:12 s52 rADA136 z0.9"; 
  if( bldfnc == "19" ) // Factory 
    return 0; // !!! Prochee
  if( bldfnc == "20" ) // Filling station 
    return "#fCityPlan01:12 s55 r8B008B z0.9";
  if( bldfnc == "21" ) // Garage 
    return "#fCityPlan01:12 s118 rE4CD65 z0.9";
  if( bldfnc == "24" ) // Hospital 
    return "#fCityPlan01:12 s59 rF55200 z0.9";
  if( bldfnc == "25" ) // Hotel 
    return "#fCityPlan01:12 s69 r7E007E z0.9";
  if( bldfnc == "31" ) // Library 
    return "#fCityPlan01:12 s67 rD2691E z0.9";
  if( bldfnc == "32" ) // Market 
    return "#fCityPlan01:12 s97 rA0522D z0.9";
  if( bldfnc == "33" ) // Municipality 
    return "#fCityPlan01:12 s57 r8B008B z0.9";
  if( bldfnc == "34" ) // Museum 
    return "#fCityPlan01:12 s52 rADA136 z0.9"; 
  if( bldfnc == "38" ) // Police 
  {
    if( chGetAttrText(ch,fe,61068,poicat) && poicat == "trafficpolice" )
      return "#fCityPlan01:12 s110 r4000FF z0.9";
    return "#fCityPlan01:12 s65 r4000FF z0.9";
  }
  if( bldfnc == "39" ) // Pharmacy/Polyclinic 
    return "#fCityPlan01:12 s60 r009240 z0.9";
  if( bldfnc == "40" ) // Pool 
    return "#fCityPlan01:12 s51 r00008B z0.9";
  if( bldfnc == "41" ) // Port, quay 
    return "#fCityPlan01:12 s79 r1E90FF z0.9";
  if( bldfnc == "42" ) // Post office 
    return "#fCityPlan01:12 s56 r9A65CC z0.9";
  if( bldfnc == "43" ) // Restaurant 
    return "#fCityPlan01:12 s113 r4682B4 z0.9";
  if( bldfnc == "45" ) // School 
    return "#fCityPlan01:12 s72 r2EB82E z0.9";
  if( bldfnc == "48" ) // Shop 
    return "#fCityPlan01:12 s122 rA0522D z0.9";
  if( bldfnc == "49" ) // Social aid organisation 
    return "#fCityPlan01:12 s57 r8B008B z0.9";
  if( bldfnc == "50" ) // Sport building, construction 
    return "#fCityPlan01:12 s51 r009240 z0.9";
  if( bldfnc == "51" ) // Stadium 
    return "#fCityPlan01:12 s51 r009240 z0.9";
  if( bldfnc == "55" ) // Supermarket 
    return "#fCityPlan01:12 s97 rA0522D z0.9";
  if( bldfnc == "57" ) // Theatre 
    return "#fCityPlan01:12 s70 r994779 z0.9";
  if( bldfnc == "59" ) // University 
    return "#fCityPlan01:12 s73 r0099D4 z0.9";
  if( bldfnc == "61" ) // Yacht-club 
    return "#fCityPlan01:12 s79 r1E90FF z0.9";
  if( bldfnc == "65" ) // Railway station 
    return "#fCityPlan01:12 s77 r858585 z0.9";
  if( bldfnc == "68" ) // Metro 
    return "#fCityPlan01:12 s103 r994779 z0.9";
  if( bldfnc == "69" ) // Mosque 
    return "#fCityPlan01:12 s46 r009240 z0.9";
  if( bldfnc == "70" ) // Pagoda 
    return "#fCityPlan01:12 s66 rFF8686 z0.9";
  if( bldfnc == "71" ) // Chapel 
    return "#fCityPlan01:12 s52 rFF8686 z0.9";
  if( bldfnc == "72" ) // Synagogue 
    return "#fCityPlan01:12 s54 rFF8686 z0.9";
  return 0;  
}

global POIGEN_pnt(ch,fe,rgb)
{
  if( !chGetFeatureNode(ch,fe,nd) )
    return 0;
  chSetGeoUnits(0);  
  if( !chGetNodeXY(ch,nd,x,y) )
    return 0;
  if( !chMap2Win(ch,x,y,x1,y1) )
    return 0;
  prpen=SelectObject(GetStockObject(BLACK_PEN));
  prbrush=SelectObject(GetStockObject(GRAY_BRUSH));
  Ellipse(x1-4,y1-4,x1+4,y1+4);
  SelectObject(prbrush);
  SelectObject(prpen);
  if( chGetAttrText(ch,fe,AT_LABELS,labels) )
  {
    fnt=CreateFont(10,0,0,0,"Arial");
    SetTextColor(0x3f3f3f);
    SetTextAlign(TA_CENTER|TA_TOP);
    prfnt=SelectObject(fnt);
    TextOut(x1,y1+5,labels);
    SelectObject(prfnt);
    DeleteObject(fnt);
  }
  return 0;  
}

global HEIMRK_pnt(ch,fe,rgb)
{
  if( GetCurScale() > 25000 )
    return;
  if( !chGetFeatureNode(ch,fe,nd) )
    return 0;
  if( !chGetAttrValue(ch,fe,17550,heival) )
    return 0;
  chSetGeoUnits(0);  
  if( !chGetNodeXY(ch,nd,x,y) )
    return 0;
  if( !chMap2Win(ch,x,y,x1,y1) )
    return 0;
  fnt=CreateFont(10,0,0,0,"Arial");
  SetTextColor(0x3f3f3f);
  SetTextAlign(TA_CENTER|TA_BASELINE);
  prfnt=SelectObject(fnt);
  TextOut(x1,y1+4,printf("%.2lf",heival));
  SelectObject(prfnt);
  DeleteObject(fnt);
  return 0;  
}

global HEIMRK_line(ch,fe,rgb)
{
  if( GetCurScale() > 25000 )
    return;
  return "#r3f3f3f";
}

global LTBLDS_pnt(ch,fe,rgb)
{
  if( !chGetAttrValue(ch,fe,60250,catlbl) )
  {
    if( !chGetAttrText(ch,fe,61068,poicat) )
      return 0;
    if( poicat == "firehouse" )
      return "#fCityPlan01:12 s65 rE60039 z0.9"; 
    if( poicat == "parking" || poicat == "trackparking" )
      return "#fCityPlan01:12 s119 r4000FF z0.9"; 
    return 0;
  }
  if( catlbl == 1 ) // Monument  
    return "#fCityPlan01:12 s33 r009933 z0.7"; 
  if( catlbl == 5 ) // Telephone box  
    return "#fCityPlan01:12 s104 r7DA8FF z0.9"; 
  if( catlbl == 7 ) // Fire tower  
    return "#fCityPlan01:12 s65 rE60039 z0.9"; 
  if( catlbl == 20 ) // Toilet  
    return 0;
  if( catlbl == 22 ) // Car repair  
    return "#fCityPlan01:12 s114 r8A8A8A z0.9";
  if( catlbl == 27 ) // Bus stop  
    return "#fCityPlan01:12 s102 r797AFF z0.9";
  return 0;
}

local drawBearing(ch,fe,ornt,dist,style,x,y,x1,y1)
{
  //chGetProperty(ch,GEO_RELATE,relate);
  chGetProperty(ch,GEO_SCALE,scale);
  dist*=1000000/scale;  // meters2dist=1000*relate/scale;
  if( !chMap2Win(ch,x+dist*sind(ornt),y-dist*cosd(ornt),x2,y2) )
    return;
  dx=x1-x2;
  if( dx < 0 )
    dx=0-dx;
  dy=y1-y2;  
  if( dy < 0 )
    dy=0-dy;
  if( dx < 6 && dy < 6 )
    return;  
  pen=CreatePen(style,1,0);    
  prpen=SelectObject(pen);
  MoveTo(x1,y1);
  LineTo(x2,y2);
  SelectObject(prpen);
  DeleteObject(pen);
  prpen=SelectObject(GetStockObject(BLACK_PEN));
  prbrush=SelectObject(GetStockObject(GRAY_BRUSH));
  Ellipse(x2-3,y2-3,x2+3,y2+3);
  SelectObject(prbrush);
  SelectObject(prpen);
}

local drawBothBearings(ch,fe,x1,y1)
{
  if( !chGetFeatureNode(ch,fe,nd) )
    return 1;
  chSetGeoUnits(0);  
  if( !chGetNodeXY(ch,nd,x,y) )
    return 1;
  if( !chMap2Win(ch,x,y,x1,y1) )
    return 1;
  if( chGetAttrValue(ch,fe,1705,orient) && chGetAttrValue(ch,fe,1706,dist) )
    drawBearing(ch,fe,orient,dist,PS_DASHDOT,x,y,x1,y1);
  if( chGetAttrValue(ch,fe,1707,orient) && chGetAttrValue(ch,fe,1708,dist) ) 
    drawBearing(ch,fe,orient,dist,PS_DASHDOTDOT,x,y,x1,y1);
  return 0;  
}

global RADARS_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  prpen=SelectObject(GetStockObject(BLACK_PEN));
  prbrush=SelectObject(GetStockObject(GRAY_BRUSH));
  Rectangle(x1-4,y1-4,x1+4,y1+4);
  SelectObject(prbrush);
  SelectObject(prpen);
  return 0;  
}

local drawSpeedLimit(ch,fe,rgb,spdlmt)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  pen=CreatePen(PS_SOLID,2,red);
  prpen=SelectObject(pen);
  prbrush=SelectObject(GetStockObject(WHITE_BRUSH));
  Ellipse(x1-8,y1-8,x1+8,y1+8);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(pen);
  fnt=CreateFont(10,0,0,0,"Arial");
  SetTextColor(black);
  SetTextAlign(TA_CENTER|TA_BASELINE);
  prfnt=SelectObject(fnt);
  TextOut(x1,y1+3,spdlmt);
  SelectObject(prfnt);
  DeleteObject(fnt);
  return 0;
}

global SPD005_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"5"); } 
global SPD010_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"10"); } 
global SPD015_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"15"); } 
global SPD020_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"20"); } 
global SPD025_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"25"); } 
global SPD030_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"30"); } 
global SPD035_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"35"); } 
global SPD040_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"40"); } 
global SPD045_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"45"); } 
global SPD050_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"50"); } 
global SPD060_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"60"); } 
global SPD070_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"70"); } 
global SPD080_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"80"); } 
global SPD090_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"90"); } 
global SPD100_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"100"); } 
global SPD110_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"110"); } 
global SPD120_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"120"); } 
global SPD130_pnt(ch,fe,rgb) { drawSpeedLimit(ch,fe,rgb,"130"); } 


global PROHIBITION_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  pen=CreatePen(PS_SOLID,2,red);
  prpen=SelectObject(pen);
  prbrush=SelectObject(GetStockObject(WHITE_BRUSH));
  Ellipse(x1-8,y1-8,x1+8,y1+8);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(pen);
  return 0;
}

global ENDLIM_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  pen=CreatePen(PS_SOLID,2,red);
  prpen=SelectObject(pen);
  prbrush=SelectObject(GetStockObject(WHITE_BRUSH));
  Ellipse(x1-8,y1-8,x1+8,y1+8);
  SelectObject(prbrush);
  SelectObject(GetStockObject(BLACK_PEN));
  MoveTo(x1-7,y1-7);
  LineTo(x1+8,y1+8);
  MoveTo(x1-7,y1+7);
  LineTo(x1+8,y1-8);
  SelectObject(prpen);
  DeleteObject(pen);
  return 0;
}

global KIRPCH_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  pen=CreatePen(PS_SOLID,1,red);
  prpen=SelectObject(pen);
  brush=CreateSolidBrush(red);
  prbrush=SelectObject(brush);
  Ellipse(x1-9,y1-9,x1+9,y1+9);
  SelectObject(GetStockObject(WHITE_PEN));
  SelectObject(GetStockObject(WHITE_BRUSH));
  Rectangle(x1-5,y1-2,x1+5,y1+2);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(brush);
  DeleteObject(pen);
  return 0;
}

global ROUNDB_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  pen=CreatePen(PS_SOLID,0,trafsignblue);
  brush=CreateSolidBrush(trafsignblue);
  prpen=SelectObject(pen);
  prbrush=SelectObject(brush);
  Ellipse(x1-8,y1-8,x1+8,y1+8);
  SelectObject(GetStockObject(WHITE_PEN));
  SelectObject(GetStockObject(NULL_BRUSH));
  Ellipse(x1-6,y1-6,x1+6,y1+6);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(brush);
  DeleteObject(pen);
  return 0;
}

global LEFTTT_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  pen=CreatePen(PS_SOLID,0,trafsignblue);
  brush=CreateSolidBrush(trafsignblue);
  prpen=SelectObject(pen);
  prbrush=SelectObject(brush);
  Ellipse(x1-8,y1-8,x1+8,y1+8);
  SelectObject(GetStockObject(WHITE_PEN));
  x1+=1;
  y1+=1;
  MoveTo(x1-3,y1+3);
  LineTo(x1-3,y1-3);
  LineTo(x1+3,y1-3);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(brush);
  DeleteObject(pen);
  return 0;
}

global RIGHTT_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  pen=CreatePen(PS_SOLID,0,trafsignblue);
  brush=CreateSolidBrush(trafsignblue);
  prpen=SelectObject(pen);
  prbrush=SelectObject(brush);
  Ellipse(x1-8,y1-8,x1+8,y1+8);
  SelectObject(GetStockObject(WHITE_PEN));
  x1-=1;
  y1+=1;
  MoveTo(x1+3,y1+3);
  LineTo(x1+3,y1-3);
  LineTo(x1-3,y1-3);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(brush);
  DeleteObject(pen);
  return 0;
}

global LEFRIG_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  pen=CreatePen(PS_SOLID,0,trafsignblue);
  brush=CreateSolidBrush(trafsignblue);
  prpen=SelectObject(pen);
  prbrush=SelectObject(brush);
  Ellipse(x1-8,y1-8,x1+8,y1+8);
  SelectObject(GetStockObject(WHITE_PEN));
  y1+=1;
  MoveTo(x1,y1+3);
  LineTo(x1,y1-2);
  LineTo(x1+5,y1-3);
  MoveTo(x1,y1-2);
  LineTo(x1-5,y1-3);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(brush);
  DeleteObject(pen);
  return 0;
}

global STRGHT_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  pen=CreatePen(PS_SOLID,0,trafsignblue);
  brush=CreateSolidBrush(trafsignblue);
  prpen=SelectObject(pen);
  prbrush=SelectObject(brush);
  Ellipse(x1-8,y1-8,x1+8,y1+8);
  SelectObject(GetStockObject(WHITE_PEN));
  MoveTo(x1,y1+5);
  LineTo(x1,y1-6);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(brush);
  DeleteObject(pen);
  return 0;
}

global LFTSTR_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  pen=CreatePen(PS_SOLID,0,trafsignblue);
  brush=CreateSolidBrush(trafsignblue);
  prpen=SelectObject(pen);
  prbrush=SelectObject(brush);
  Ellipse(x1-8,y1-8,x1+8,y1+8);
  SelectObject(GetStockObject(WHITE_PEN));
  x1+=1;
  MoveTo(x1,y1+5);
  LineTo(x1,y1-6);
  MoveTo(x1,y1);
  LineTo(x1-6,y1);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(brush);
  DeleteObject(pen);
  return 0;
}

global RIGSTR_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  pen=CreatePen(PS_SOLID,0,trafsignblue);
  brush=CreateSolidBrush(trafsignblue);
  prpen=SelectObject(pen);
  prbrush=SelectObject(brush);
  Ellipse(x1-8,y1-8,x1+8,y1+8);
  SelectObject(GetStockObject(WHITE_PEN));
  x1-=1;
  MoveTo(x1,y1+5);
  LineTo(x1,y1-6);
  MoveTo(x1,y1);
  LineTo(x1+6,y1);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(brush);
  DeleteObject(pen);
  return 0;
}

global PASPAS_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  x1=int(x1+0.5);  
  y1=int(y1+0.5);  
  pen=CreatePen(PS_SOLID,0,trafsignblue);
  brush=CreateSolidBrush(trafsignblue);
  prpen=SelectObject(pen);
  prbrush=SelectObject(brush);
  Rectangle(x1-7,y1-7,x1+7,y1+7);
  SelectObject(GetStockObject(WHITE_BRUSH));
  SelectObject(GetStockObject(WHITE_PEN));
  xy=ArCreate(6);
  ArSetAt(xy,1,x1);     ArSetAt(xy,2,y1-6);
  ArSetAt(xy,3,x1-6);   ArSetAt(xy,4,y1+4);
  ArSetAt(xy,5,x1+5);   ArSetAt(xy,6,y1+4);
  Polygon(xy);
  ArFree(xy);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(brush);
  DeleteObject(pen);
  return 0;
}

global WARNINGSIGN_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  x1=int(x1+0.5);  
  y1=int(y1+0.5);  
  pen=CreatePen(PS_SOLID,2,red);
  prpen=SelectObject(pen);
  prbrush=SelectObject(GetStockObject(WHITE_BRUSH));
  MoveTo(x1,y1-4);
  xy=ArCreate(6);
  ArSetAt(xy,1,x1);     ArSetAt(xy,2,y1-10);
  ArSetAt(xy,3,x1-8);   ArSetAt(xy,4,y1+4);
  ArSetAt(xy,5,x1+8);   ArSetAt(xy,6,y1+4);
  Polygon(xy);
  ArFree(xy);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(pen);
  return 0;
}

global GIVWAY_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  x1=int(x1+0.5);  
  y1=int(y1+0.5);  
  pen=CreatePen(PS_SOLID,2,red);
  prpen=SelectObject(pen);
  prbrush=SelectObject(GetStockObject(WHITE_BRUSH));
  MoveTo(x1,y1-4);
  xy=ArCreate(6);
  ArSetAt(xy,1,x1);     ArSetAt(xy,2,y1+10);
  ArSetAt(xy,3,x1-8);   ArSetAt(xy,4,y1-4);
  ArSetAt(xy,5,x1+8);   ArSetAt(xy,6,y1-4);
  Polygon(xy);
  ArFree(xy);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(pen);
  return 0;
}

global DNGCRS_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  x1=int(x1+0.5);  
  y1=int(y1+0.5);  
  pen=CreatePen(PS_SOLID,2,red);
  prpen=SelectObject(pen);
  prbrush=SelectObject(GetStockObject(WHITE_BRUSH));
  MoveTo(x1,y1-4);
  xy=ArCreate(6);
  ArSetAt(xy,1,x1);     ArSetAt(xy,2,y1-10);
  ArSetAt(xy,3,x1-8);   ArSetAt(xy,4,y1+4);
  ArSetAt(xy,5,x1+8);   ArSetAt(xy,6,y1+4);
  Polygon(xy);
  ArFree(xy);
  SelectObject(GetStockObject(BLACK_PEN));
  MoveTo(x1-2,y1-2);
  LineTo(x1+3,y1+3);
  MoveTo(x1-2,y1+2);
  LineTo(x1+3,y1-3);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(pen);
  return 0;
}

global SNSTOP_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  x1=int(x1+0.5);  
  y1=int(y1+0.5);  
  pen=CreatePen(PS_SOLID,1,red);
  prpen=SelectObject(pen);
  brush=CreateSolidBrush(red);
  prbrush=SelectObject(brush);
  MoveTo(x1,y1-4);
  xy=ArCreate(16);
  ArSetAt(xy,1,x1-8);     ArSetAt(xy,2,y1-4);
  ArSetAt(xy,3,x1-4);     ArSetAt(xy,4,y1-8);
  ArSetAt(xy,5,x1+4);     ArSetAt(xy,6,y1-8);
  ArSetAt(xy,7,x1+8);     ArSetAt(xy,8,y1-4);
  ArSetAt(xy,9,x1+8);     ArSetAt(xy,10,y1+4);
  ArSetAt(xy,11,x1+4);    ArSetAt(xy,12,y1+8);
  ArSetAt(xy,13,x1-4);    ArSetAt(xy,14,y1+8);
  ArSetAt(xy,15,x1-8);    ArSetAt(xy,16,y1+4);
  Polygon(xy);
  ArFree(xy);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(brush);
  DeleteObject(pen);
  fnt=CreateFont(7,0,0,0,"Arial");
  SetTextColor(white);
  SetTextAlign(TA_CENTER|TA_BASELINE);
  prfnt=SelectObject(fnt);
  TextOut(x1+1,y1+3,"STOP");
  SelectObject(prfnt);
  DeleteObject(fnt);
  return 0;
}

global SPORTS_pnt(ch,fe,rgb)
{
  if( chGetAttrText(ch,fe,61068,poicat) && ( poicat == "pool" || poicat == "diving" ) )
    return "#fCityPlan01:12 s51 r00008B z0.9";
  return 1;  
}

global TRLMAN_pnt(ch,fe,rgb)
{
  if( drawBothBearings(ch,fe,x1,y1) )
    return 0;
  x1=int(x1+0.5);  
  y1=int(y1+0.5);  
  pen=CreatePen(PS_SOLID,0,trafsignblue);
  brush=CreateSolidBrush(trafsignblue);
  prpen=SelectObject(pen);
  prbrush=SelectObject(brush);
  Rectangle(x1-7,y1-7,x1+7,y1+7);
  SelectObject(GetStockObject(WHITE_PEN));
  MoveTo(x1,y1-5);
  LineTo(x1,y1+5);
  MoveTo(x1-3,y1-5);
  LineTo(x1-3,y1+5);
  MoveTo(x1+3,y1-5);
  LineTo(x1+3,y1+5);
  SelectObject(prbrush);
  SelectObject(prpen);
  DeleteObject(brush);
  DeleteObject(pen);
  return 0;
}

global CAPITA_pnt(ch,fe,rgb)
{
  if( !chGetFeatureNode(ch,fe,nd) )
    return 0;
  chSetGeoUnits(0);  
  if( !chGetNodeXY(ch,nd,x,y) )
    return 0;
  if( !chMap2Win(ch,x,y,x1,y1) )
    return 0;
  brush=BLACK_BRUSH;  
  if( !chGetAttrValue(ch,fe,AT_CATCAP,catcap) || catcap > 5 )
  {
    sz=3;  
    brush=NULL_BRUSH;
  }  
  else if( catcap == 5 )  
    sz=3;
  else if( catcap == 4 )  
    sz=5;
  else if( catcap == 3 )  
    sz=7;
  else if( catcap == 2 )  
    sz=9;
  else  if( catcap == 1 )  
    sz=11;
  fnthei=12;
  prpen=SelectObject(GetStockObject(BLACK_PEN));
  prbrush=SelectObject(GetStockObject(brush));
  Ellipse(x1-sz,y1-sz,x1+sz,y1+sz);
  SelectObject(prbrush);
  SelectObject(prpen);
  
  if( !chGetAttrText(ch,fe,AT_LABELS,txt) )
    return;
  logx=GetDeviceCaps(LOGPIXELSX);
  if( !chGetAttrValue(ch,fe,AT_FNTHEI,fnthei) )
    fnthei=10;
  if( !(fnt=CreateFont(-int(fnthei*logx/72.+0.5),0,0,0,"Tahoma")) )
    return;
  SetTextColor(black);
  SetTextAlign(TA_CENTER|TA_TOP);
  prfnt=SelectObject(fnt);
  TextOut(x1,y1+sz,txt);
  DeleteObject(SelectObject(prfnt));
  return 0;  
}

local drawEntryExit(ch,nd)
{
  if( !chGetNodeXY(ch,nd,x,y) || !chMap2Win(ch,x,y,x1,y1) )
    return;
  prpen=SelectObject(GetStockObject(BLACK_PEN));
  brush=CreateSolidBrush(green);
  prbrush=SelectObject(brush);
  Rectangle(x1-5,y1-5,x1+5,y1+5);
  SelectObject(prbrush);
  DeleteObject(brush);
  SelectObject(prpen);
}

global ENTEXI_pnt(ch,fe,rgb)
{
  if( chGetFeatureNode(ch,fe,nd) )
    drawEntryExit(ch,nd);  
}

global ADRESS_pnt(ch,fe,rgb)
{
  //puts("adr:"+fe);
  if( !chGetAttrText(ch,fe,AT_NUMBER,txt) )
    return;
  if( !chGetFeatureNode(ch,fe,nd) || !chGetNodeXY(ch,nd,x,y) || !chMap2Win(ch,x,y,x1,y1) )
    return;
  if( !chGetAttrValue(ch,fe,AT_FNTHEI,fnthei) )
    fnthei=7;
  if( !(fnt=CreateFont(-int(fnthei*GetDeviceCaps(LOGPIXELSX)/72.+0.5),0,0,0,"Tahoma")) )
    return;
  SetTextColor(black);
  SetTextAlign(TA_CENTER|TA_BASELINE);
  prfnt=SelectObject(fnt);
  TextOut(x1,y1,txt);
  DeleteObject(SelectObject(prfnt));
}
