include <LookUp2DInc.dh>
include <system.dh>
include <windows.dh>

const FE_STREET 60160
const FE_NOTURN 1666
const AT_SCALVL 1703

local error(txt)
{
  MessageBox(txt,MB_OK|MB_ICONSTOP);
  exit(0);
}

local distLne2Pnt2(xa,ya,xb,yb,x,y)
{
  dx=xa-xb;
  dy=ya-yb;
  r=dx*dx+dy*dy;
  if( r )
    r=((ya-y)*dy+(xa-x)*dx)/r;
  if( r <= 0 )
  {
    dx=xa;
    dy=ya;
  }
  else if( r >= 1 )
  {
    dx=xb;
    dy=yb;
  }
  else
  {
    dx=xa-r*dx;
    dy=ya-r*dy;
  }
  dx-=x;
  dy-=y;
  return dx*dx+dy*dy;
}

local minDist2Edge(ch,eg,x,y)
{
  mindst=0x7ffffff;
  len=chGetEdgeXY(ch,eg,0,x1,y1);
  for( i=1; i<=len; i+=1 )
  {
    chGetEdgeXY(ch,eg,i,x2,y2);
    d2=distLne2Pnt2(x1,y1,x2,y2,x,y);
    if( mindst > d2 )
      mindst=d2;
    x1=x2;
    y1=y2;
  }
  return mindst;
}

local findEdge(ch,fe)
{
  sz=chGetFeatureLine(ch,fe,1,eg,flag);
  if( sz == 1 )
    return eg;
  if( !GetResource("MapX",x) || !GetResource("MapY",y) )
    return 0;
  mindst=minDist2Edge(ch,eg,x,y);  
  for( i=2; i<=sz; i+=1 )
  {
    chGetFeatureLine(ch,fe,i,eg2,flag);
    if( mindst > (d=minDist2Edge(ch,eg2,x,y)) )
    {
      mindst=d;
      eg=eg2;
    }  
  }
  return eg;  
}

global main()
{
  OnError(ERR_IGNORE);
  if( !GetResource("Object",fe) )
    error("Illegal script: object is not defined");
  if( !(ch=GetEditDataset()) )
    return;
  if( !(eg=findEdge(ch,fe)) )
    error("Cannot select edge");
  if( GetResource("NoTurn",fe) )
  {
    DeleteResource("NoTurn");
    if( chGetFeatureCode(ch,fe) != FE_NOTURN )
      return;
    if( findEdge(ch,fe) == eg )
      chDelFeature(ch,fe);
    else
    {  
      chGetFeatureLine(ch,fe,1,eg1,flag);
      chGetEdgeBegEnd(ch,eg1,b1,e1);
      chGetEdgeBegEnd(ch,eg,b2,e2);
      if( e1 == b2 )
        chIncFeatureLine(ch,fe,2,eg,0);
      else if( e1 == e2 )
        chIncFeatureLine(ch,fe,2,eg,M_REVERSE);
      else if( b1 == b2 )
      {
        chEdiFeatureLine(ch,fe,eg1,eg1,M_REVERSE);
        chIncFeatureLine(ch,fe,2,eg,0);
      }
      else if( b1 == e2 )
      {
        chEdiFeatureLine(ch,fe,eg1,eg1,M_REVERSE);
        chIncFeatureLine(ch,fe,2,eg,M_REVERSE);
      }
      else if( IDYES == MessageBox("     .   ?",MB_ICONEXCLAMATION|MB_YESNO) )
        SetResource("NoTurn",fe);
      else  
        chDelFeature(ch,fe);
    }
  }
  else
  {
    if( !chGetAttrValue(ch,fe,AT_SCALVL,scalvl) )
      scalvl=0;
    fe=chCrtFeature(ch,FE_NOTURN);
    chSetAttrText(ch,fe,SORIND,str(fe));
    if( scalvl )
      chSetAttrValue(ch,fe,AT_SCALVL,scalvl);
    chIncFeatureLine(ch,fe,1,eg,0);
    SetResource("NoTurn",fe);
  }
  chUpdateFeature(ch,fe);
  chUpdatePresentation(ch);
  Redraw();
}
