include <system.dh>
include <LookUp2DInc.dh>

const FE_GORODA 18108

const AT_LABELS 17501
const AT_TWNNAM 61063

global main()
{
  if( !(ch=GetEditDataset()) )
    return;
  ar=ArCreate(0);  
  
  StartIndicator("Processing...",chFeatureNum(ch)*2);
  
  for( fe=0; fe=chNextFeature(ch,fe); )
  {
    StepIndicator();
    if( FE_GORODA == chGetFeatureCode(ch,fe) && chGetAttrText(ch,fe,AT_LABELS,labels) )
    {
      //labels=StrRTrim(StrLTrim(labels," ")," ");
      ArAdd(ar,StrLwr(labels));
    }  
  }
  
  if( !ArSize(ar) )
  {
    ArFree(ar);
    puts("Nothing to do: no settlements");
    return 1;
  }
  
  ArSort(ar,ar);
  for( i=ArSize(ar); i>1; i-=1 )
    if( ArGet(ar,i) == ArGet(ar,i-1) )
      ArRemoveAt(ar,i);

  res=ArCreate(0);
  names=ArCreate(0);
  for( fe=0; fe=chNextFeature(ch,fe); )
  {
    StepIndicator();
    if( chGetAttrText(ch,fe,AT_TWNNAM,twnnam) && !ArBSearch(ar,StrLwr(twnnam)) )
    {
      ArAdd(res,fe);
      //twnnam=StrRTrim(StrLTrim(twnnam," ")," ");
      ArAdd(names,twnnam);
    }
  }
  
  if( ArSize(res) )
  {
    ClearQuery(0);
    QueryFeatures(res,0);
    ArSort(names,names);
    totnum=tot=1;
    for( i=2; i<=ArSize(names); i+=1 )
    {
      if( ArGet(names,i-1) == ArGet(names,i) )
        tot+=1;
      else
      {
        totnum+=1;
        puts(ArGet(names,i-1)+": "+tot);
        tot=1;
      }  
    }
    puts(ArGet(names,i-1)+": "+tot);
  }  
  puts("Total non-existing settlements: "+totnum);
  
  ArFree(ar);
  ArFree(res);
  ArFree(names);
  
  FinishIndicator();
}
