include <dKart.dh>
include <windows.dh>

const OBJ_CODE_ADDR	1651
const ATTR_CODE_ADDR	102
const ATTR_CODE_STREET	148

const POI_ATTR_CODE_ADDR	60040
const POI_ATTR_CODE_STREET	60030

const DIST_TOL	0.001

global main()
{
	if( !(ch=GetEditDataset()) )
	{
		puts( "ERROR: Unable to load POI chart" );
		return;
	}
	
    if( OpenFileDlg( filename,"","",-1,"DCF files (*.dcf)|*.dcf|All files  (*.*)|*.*||") != IDOK )
	{
		puts( "ERROR: AddrBase file not found" );
		return;
	}

	if( !(chAddr = LoadDataset(filename)) )
	{
		puts( "ERROR: Unable to load AddrBase chart" );
		return;
	}

    chSetGeoUnits( 1 );

	for ( chObj = chNextFeature( ch, NULL ); chObj; chObj = chNextFeature( ch, chObj ) )
	{
		if ( (chGetMetricType(ch, chObj) != M_NODE) )
			continue;

		strStreet = "";
		chGetAttrText(ch, chObj, POI_ATTR_CODE_STREET, strStreet);
		strAddr = "";
		chGetAttrText(ch, chObj, POI_ATTR_CODE_ADDR, strAddr);
        if ( (StrLen(strStreet) > 0)
            &&(StrLen(strAddr) > 0) )
			continue;

		node = NULL;
		chGetFeatureNode( ch, chObj, node );
		nodX = 0.;
		nodY = 0.;
		chGetNodeXY( ch, node, nodX, nodY );
	    
        minDist = 100;
        chObjFindAddr = NULL;
        for ( chObjAddr = chNextFeature( chAddr, NULL ); chObjAddr; chObjAddr = chNextFeature( chAddr, chObjAddr) )
	    {
		    if ( (chGetFeatureCode(chAddr, chObjAddr) != OBJ_CODE_ADDR)
			    ||(chGetMetricType(chAddr, chObjAddr) != M_NODE) )
			    continue;
		    nodeAddr = NULL;
		    chGetFeatureNode( chAddr, chObjAddr, nodeAddr );
		    nodAddrX = 0.;
		    nodAddrY = 0.;
		    chGetNodeXY( chAddr, nodeAddr, nodAddrX, nodAddrY );

            dX = fabs(nodX-nodAddrX);
            if ( dX > DIST_TOL )
			    continue;
            dY = fabs(nodY-nodAddrY);
            if ( dY > DIST_TOL )
			    continue;

            dist = dX*dX + dY*dY;
            if ( dist < minDist )
            {
                chObjFindAddr = chObjAddr;
                minDist = dist;
                if ( minDist == 0 )
                    break;
            }
        }

        if ( !chObjFindAddr )
        {
            puts( "Addr not found for POI #" + chObj );
            continue;
        }
        
		strAttr = "";
		chGetAttrText(chAddr, chObjFindAddr, ATTR_CODE_STREET, strAttr);
        if ( !StrLen(strStreet)
            &&(StrLen(strAttr) > 0) )
            chSetAttrText( ch, chObj, POI_ATTR_CODE_STREET, strAttr );

		strAttr = "";
		chGetAttrText(chAddr, chObjFindAddr, ATTR_CODE_ADDR, strAttr);
        if ( !StrLen(strAddr)
            &&(StrLen(strAttr) > 0) )
            chSetAttrText( ch, chObj, POI_ATTR_CODE_ADDR, strAttr );
	}

    CloseDataset( chAddr );

	puts( "Conversion successfully compleated" );
}