include <dKart.dh>
include <windows.dh>

const OBJ_CODE_SREET		1652
const ATTR_CODE_DIR		1651
const ATTR_CODE_SPEED		1653
const ATTR_CODE_STRNAME	102


const DIST_TOL	0.0005

local borderXborder( ch1, ch2, line1, line2 )
{
	x1 = 0.;
	x2 = 0.;
	y1 = 0.;
	y2 = 0.;
	chFeatureBorder( ch1, line1, x1, y1, x2, y2 );
	x1 = x1 - DIST_TOL;
	y1 = y1 - DIST_TOL;
	x2 = x2 + DIST_TOL;
	y2 = y2 + DIST_TOL;
	x1_0 = 0.;
	x2_0 = 0.;
	y1_0 = 0.;
	y2_0 = 0.;
	chFeatureBorder( ch2, line2, x1_0, y1_0, x2_0, y2_0 );
	x1_0 = x1_0 - DIST_TOL;
	y1_0 = y1_0 - DIST_TOL;
	x2_0 = x2_0 + DIST_TOL;
	y2_0 = y2_0 + DIST_TOL;
	if ( x1 <= x2_0 && x1_0 <= x2 &&
		  y1 <= y2_0 && y1_0 <= y2 )
		  return 1;
	return 0;
}

local IsPointsSame( chIn, chOut, edgeIn, edgeOut, numIn, numOut )
{
	inX = 0.;
	inY = 0.;
	chGetEdgeXY( chIn, edgeIn, numIn, inX, inY );
	outX = 1.;
	outY = 1.;
	chGetEdgeXY( chOut, edgeOut, numOut, outX, outY );
	if ( (fabs(inX-outX) < DIST_TOL)
		&&(fabs(inY-outY) < DIST_TOL) )
		return 1;
	return 0;
}


local IsSameEdges( chIn, chOut, edgeIn, edgeOut )
{
	x=0;
	y=0;
	numIn = chGetEdgeXY( chIn, edgeIn, 0, x, y );
	numOut = chGetEdgeXY( chOut, edgeOut, 0, x, y );
	if ( IsPointsSame( chIn, chOut, edgeIn, edgeOut, 0, 0 ) )
	{
		if ( /*!IsPointsSame( chIn, chOut, edgeIn, edgeOut, 1, 1 )
			||*/!IsPointsSame( chIn, chOut, edgeIn, edgeOut, numIn-1, numOut-1 )
			/*||!IsPointsSame( chIn, chOut, edgeIn, edgeOut, numIn-2, numOut-2 )*/ )
			return 0;
		return 1;
	}
/*	else
	{
		if ( !IsPointsSame( chIn, chOut, edgeIn, edgeOut, numIn-1, 0 )
			||!IsPointsSame( chIn, chOut, edgeIn, edgeOut, 0, numOut-1 )
			return 0;
		return 2;
	}*/
	return 0;
}


global main()
{
	if( !(chIn=GetEditDataset()) )
	{
		puts( "ERROR: Unable to load active chart" );
		return;
	}

	filename = "";
	if( OpenFileDlg( filename,"","",-1,"DCF files (*.dcf)|*.dcf|All files  (*.*)|*.*||") != IDOK )
	{
		puts( "ERROR: Input file not found" );
		return;
	}

	if( !(chOut=LoadDataset(filename)) )
	{
		puts( "ERROR: Unable to load \"input\" chart" );
		return;
	}

	filename1 = "";
	if( SaveFileDlg( filename1,"","",-1,"TXT files (*.txt)|*.txt|All files  (*.*)|*.*||") != IDOK )
	{
		puts( "ERROR: Output file not found" );
		return;
	}

	if ( !(file = fopen( filename1, "w" )) )
	{
		puts( "ERROR: Unable to open file" );
		return;
	}

    fputs( "Active chart\t" + filename + "\n", file );
    chSetGeoUnits( 1 );

	chEdgeOut = NULL;
	arEdgesOut = ArCreate( 0 );
    for ( chEdgeOut = chNextEdge(chOut, NULL); chEdgeOut; chEdgeOut = chNextEdge(chOut, chEdgeOut) )
    {
		ArAdd( arEdgesOut, chEdgeOut );
    }

	notFoundEdges = 0;
//    counter = 0;
    puts( "ERROR: Unable to find same active chart edge:" );
    for ( chEdgeOut = chNextEdge(chIn, NULL); chEdgeOut; chEdgeOut = chNextEdge(chIn, chEdgeOut) )
	{
//		counter += 1;
//		if ( counter == 1000 )
//			break;

		bFind = 0;
        if ( chEdgeOut < chEdgeNum(chOut) )
        {
            ret = IsSameEdges(chIn, chOut, chEdgeOut, chEdgeOut);
            if ( ret == 1 )
            {
                fputs( str(chEdgeOut) + "\t" + str(chEdgeOut) + "\n", file );
                bFind = 1;
            }
        }
        if ( !bFind )
        {
		    for ( i=1; i<=ArSize(arEdgesOut); i+=1 )
		    {
                ret = IsSameEdges(chIn, chOut, chEdgeOut, ArGet(arEdgesOut, i));
                if ( !ret )
                    continue;

                if ( ret == 1 )
                    fputs( str(chEdgeOut) + "\t" + str(ArGet(arEdgesOut, i)) + "\n", file );
                else if ( ret == 2 )
                {
                    puts( str(-ArGet(arEdgesOut, i)) );
                    fputs( str(chEdgeOut) + "\t" + str(-ArGet(arEdgesOut, i)) + "\n", file );
                }
			    ArRemoveAt( arEdgesOut, i );
                bFind = 1;
			    break;
		    }
        }

		if ( !bFind )
		{
            puts( str(chEdgeOut) );
			notFoundEdges += 1;
		}
	}

    ArFreeAll();
    CloseDataset( chOut );
	CloseDataset( chIn );
	puts( "Total not found edges: " + str(notFoundEdges) );

	fclose( file );
	puts( "Conversion successfully compleated" );
}