include <windows.dh>
include <system.dh>
include <LookUp2DInc.dh>

const SAY_SPEED   1
const SAY_NOTURN  2
const SAY_ONEWAY  4
const SAY_MARKER  8
const SAY_ROACLS  16
const SAY_NOTRANS 32
const SAY_PAID    64

local sordat 20060425

local copy(ch,fe)
{
  code=chGetFeatureCode(ch,fe);
  ds=chGetFeatureDictionary(ch,fe);
  fe2=chCrtFeature(ch,code,ds);
  for( i=dsObjAttr(ds,code,0); i; i-=1 )
  {
    atcode=dsObjAttr(ds,code,i);
    if( chGetAttrText(ch,fe,atcode,val) )
      chSetAttrText(ch,fe2,atcode,val);
  }
  return fe2;
}

local splitLine(ch,fe)
{
  for( i=chGetFeatureLine(ch,fe,0,null,null); i>1; i-=1 )
  {
    chGetFeatureLine(ch,fe,i,eg,flag);
    fe2=copy(ch,fe);
    chIncFeatureLine(ch,fe2,1,eg,flag);
    chEdiFeatureLine(ch,fe,eg,0,0);
  }
}

local chkNoTurn(ch,eg1,eg2,flag1,flag2)
{
  chGetEdgeBegEnd(ch,eg1,b1,e1);
  if( eg2 & 0x1000000 )
  {
    eg2&=0xffffff;
    reversed=1;
  }
  else
    reversed=0;
  chGetEdgeBegEnd(ch,eg2,b2,e2);
  flag1=flag2=0;
  if( b1 == b2 && e1 == e2 )
  {
    if( reversed )
      flag2=M_REVERSE;
    else
      flag1=M_REVERSE;
  }
  else if( b1 == e2 && e1 == b2 )
  {
    if( reversed )
      flag1=flag2=M_REVERSE;
  }
  else if( e1 == e2 )
    flag2=M_REVERSE;
  else if( b1 == b2 )
    flag1=M_REVERSE;
  else if( b1 == e2 )
    flag1=flag2=M_REVERSE;
  else if( e1 != b2 )
  {
    puts("Wrong pair "+eg1+"+"+eg2);
    return 0;
  }
  if( reversed )
    return 2;
  return 1;
}

global main()
{
  if( !(ch=GetEditDataset()) )
    return;
  chSplitAttrs(ch);  
  if( chGetProperty(ch,CH_DICTNUM,ds) && ds == 1 && chGetProperty(ch,CH_DICT1,ds) && ds == 64003 )
  {
    if( !chGetProperty(ch,CH_NAME,fname) )
      return;
    if( !StrICmp(StrRight(fname,7),".mp.dcf") )
      fname=StrLeft(fname,StrLen(fname)-7);
    else if( !StrICmp(StrRight(fname,4),".dcf") )
      fname=StrLeft(fname,StrLen(fname)-4);
    infname=fname+"--InfRouter.dcf";
    subname=fname+"--SubRouter.dcf";
    for( inf=0; inf=NextDataset(inf); )
    {
      if( inf == ch )
        continue;
      if( !chGetProperty(inf,CH_NAME,fn) )
        continue;
      if( !StrICmp(fn,infname) )
        break;
    }
    if( !inf && !(inf=LoadDataset(infname)) )
    {
      MessageBox("Cannot find "+infname,MB_OK);
      return;
    }  
    for( sub=0; sub=NextDataset(sub); )
    {
      if( sub == ch )
        continue;
      if( !chGetProperty(sub,CH_NAME,fn) )
        continue;
      if( !StrICmp(fn,subname) )
        break;
    }
    if( !sub && (fp=fopen(subname,"rb")) )
    {
      fclose(fp);  
      sub=LoadDataset(subname);
    }
    if( OpenFileDlg(fn,"","",-1,"Update file  (*.user.upd;*.prod.upd)|*.user.upd;*.prod.upd|All files  (*.*)|*.*||") != IDOK )
      return;
    LoadTrafficUpdate(ch,inf,sub,fn,SAY_SPEED|SAY_NOTURN|SAY_ONEWAY|SAY_MARKER|SAY_ROACLS|SAY_NOTRANS|SAY_PAID);
    chUpdatePresentation(ch);
    Redraw();
    return;
  }
    
  //if( MessageBox("Did you split streets?",MB_ICONQUESTION|MB_YESNO) == IDNO )
  //  return;
  if( OpenFileDlg(fn,"","",-1,"Update file  (*.user.upd;*.prod.upd)|*.user.upd;*.prod.upd|All files  (*.*)|*.*||") != IDOK )
    return;
  if( !(fp=fopen(fn,"rb")) )
  {
    puts("*** cannot open file "+fn);
    return;
  }
  chCompact(ch,0);
  a=ArCreate(0);
  for( fe=0; fe=chNextFeature(ch,fe); )
    if( chGetFeatureCode(ch,fe) == FE_LINE &&
        chGetMetricType(ch,fe) == M_LINE &&
        chGetAttrValue(ch,fe,AT_LAYERS,layer) && layer >= 1 && layer <= 3  )
      ArAdd(a,fe);
  StartIndicator("Splitting lines...",ArSize(a));
  for( i=ArSize(a); i; i-=1 )
  {
    StepIndicator();
    splitLine(ch,ArGet(a,i));
  }
  ArFree(a);
  freadi4(ver,fp);
  puts("Update format: "+ver);
  version=-1;
  if( ver > 2 )
  {
    freadi2(version,fp);
    puts("Chart version: "+version);
  }
  freadi4(num1,fp);
  ens=ArCreate(0);
  for( i=0; i<num1; i+=1 )
  {
    freadi4(en,fp);
    ArAdd(ens,en);
  } 
  freadi4(num2,fp);
  if( num2 && ver > 1 )
    freadi4(dropnum,fp);
  else  
    dropnum=0;
  not=ArCreate(0);  
  for( i=0; i<num2; i+=1 )
  {
    freadi4(en,fp);
    ArAdd(not,en);
  } 
  freadi4(num3,fp);
  way=ArCreate(0);  
  for( i=0; i<num3; i+=1 )
  {
    freadi4(en,fp);
    ArAdd(way,en);
  } 
  fclose(fp);
  nmark=nacc=0;
  for( i=1; i<=num1; i+=1 )
  {
    eg=ArGet(ens,i);
//puts(printf("%x",eg));
    spd=eg&0xFF;
    for( j=8; j; j-=1 )
      eg=int(eg/2)&0x7FFFFFFF;
//if( i == 13 )
//  puts(">>"+printf("%x",spd)+" "+printf("%x",eg)+" "+printf("%x",ArGet(ens,i)));
    n=fen=0;
    //direg=eg&0xFFF00000;
    if( eg != (eg&0xFFFFF) )
    {
      puts("*** splitted traffic on edge "+(eg&0xFFFFF));
      eg&=0xFFFFF;
    }
    if( (fes=chGetFeaturesOfEdge(ch,eg)) )
    {
      for( k=ArSize(fes); k; k-=1 )
      {
        if( chGetAttrValue(ch,ArGet(fes,k),AT_LAYERS,layer) && layer >= 1 && layer <= 3 )
        {
          fen=ArGet(fes,k);
          n+=1;
        }
      }
      ArFree(fes);
    }
    if( n == 1 && chGetFeatureLine(ch,fen,0,eg2,flag) == 1 && eg2 == eg )
    {
      chSetAttrValue(ch,fen,AT_PRIORT,spd);
      if( sordat )
        chSetAttrValue(ch,fen,SORDAT,sordat);
      nacc+=1;
    }
    else
    {
      //puts(">>"+eg2+" "+eg);
      fe=chCrtFeature(ch,FE_LINE);
      chSetAttrText(ch,fe,AT_RGBNAM,"red");
      chSetAttrText(ch,fe,AT_WIDTH,"200");
      chSetAttrValue(ch,fe,AT_LAYERS,spd);
      chIncFeatureLine(ch,fe,0,eg,0);
      if( sordat )
        chSetAttrValue(ch,fe,SORDAT,sordat);
      nmark+=1;
    }
  }
  puts("Speed:   "+num1+"   accepted: "+nacc+"   marked: "+nmark);
  puts("No turn: "+int(num2/2)+"("+int(dropnum/2)+")");
  for( i=1; i<=dropnum; i+=2 )
  {
    eg1=ArGet(not,i);
    eg2=ArGet(not,i+1);
    if( !(rev=chkNoTurn(ch,eg1,eg2,flag1,flag2)) )
      continue;
    for( fe=0; fe=chNextFeature(ch,fe); )
    {
      if( !chGetAttrValue(ch,fe,AT_LAYERS,layer) || layer != 4 )
        continue;
      if( chGetFeatureLine(ch,fe,1,e1,f1) != 2 ||
          chGetFeatureLine(ch,fe,2,e2,f2) != 2 )
      {
        puts("wrong turn #"+fe); 
        continue;
      }
      if( e1 == eg1 && e2 == eg2 && ( rev == 1 || f1 == flag2 && f2 == flag2 ) )
      {
        chDelFeature(ch,fe);
        if( rev == 2 )
          rev="R";
        else
          rev="";
        puts("Deleted turn "+eg1+"-"+eg2+rev);
        break;
      }
    }
    if( !fe )
    {
      if( rev == 2 )
        rev="R";
      else
        rev="";
      puts("Turn not found "+eg1+"-"+eg2+rev);
    }
  }
  for( i=dropnum+1; i<=num2; i+=2 )
  {
    eg1=ArGet(not,i);
    eg2=ArGet(not,i+1);
    if( !(rev=chkNoTurn(ch,eg1,eg2,flag1,flag2)) )
      continue;
    fe=chCrtFeature(ch,FE_LINE);
    chSetAttrText(ch,fe,INFORM,"-= No Turn =-");
    chSetAttrText(ch,fe,AT_PRIORT,str(fe));
    chSetAttrText(ch,fe,AT_NAME,"noturn");
    chSetAttrText(ch,fe,AT_LAYERS,"4");
    chIncFeatureLine(ch,fe,1,eg1,flag1);
    chIncFeatureLine(ch,fe,2,eg2,flag2);
    if( sordat )
      chSetAttrValue(ch,fe,SORDAT,sordat);
  }
  nacc=nmark=0;
  for( i=1; i<=num3; i+=1 )
  {
    eg=ArGet(way,i);
    dir=eg&0xFF;
    for( j=8; j; j-=1 )
      eg=int(eg/2);
    n=fen=0;
    if( (fes=chGetFeaturesOfEdge(ch,eg)) )
    {
      for( k=ArSize(fes); k; k-=1 )
      {
        if( chGetAttrValue(ch,ArGet(fes,k),AT_LAYERS,layer) && layer >= 1 && layer <= 3 )
        {
          fen=ArGet(fes,k);
          n+=1;
        }
      }
      ArFree(fes);
    }
    if( n == 1 && chGetFeatureLine(ch,fen,0,eg2,flag) == 1 && eg2 == eg )
    {
      if( dir == 3 )
      {
        //chSetAttrText(ch,fen,AT_NAME,"street40");
        chSetAttrText(ch,fen,AT_NAME,"strstd");
        puts("Direction of "+eg+": <->");
        dir=1;
      }
      else if( dir == 1 )
      {
        if( flag & M_REVERSE )
        {
          //chSetAttrText(ch,fen,AT_NAME,"oneway2");
          puts("Direction of "+eg+": <-");
          dir=3;
        }
        else
        {
          //chSetAttrText(ch,fen,AT_NAME,"oneway1");
          puts("Direction of "+eg+": ->");
          dir=2;
        }
      }
      else if( dir == 2 )
      {
        if( flag & M_REVERSE )
        {
          //chSetAttrText(ch,fen,AT_NAME,"oneway1");
          puts("Direction of "+eg+": ->");
          dir=2;
        }
        else
        {
          //chSetAttrText(ch,fen,AT_NAME,"oneway2");
          puts("Direction of "+eg+": <-");
          dir=3;
        }
      }
      else
      {
        puts("Wrong direction "+dir);
        continue;
      }
      chSetAttrValue(ch,fen,AT_LAYERS,dir);
      if( sordat )
        chSetAttrValue(ch,fen,SORDAT,sordat);
      nacc+=1;
    }
    else
    {
      //puts(">>"+eg2+" "+eg);
      //n=chGetFeatureLine(ch,fen,0,eg2,flag);
      //puts(">"+n+" "+eg2+" "+eg);
      fe=chCrtFeature(ch,FE_LINE);
      chSetAttrText(ch,fe,AT_RGBNAM,"red");
      chSetAttrText(ch,fe,AT_WIDTH,"100");
      chSetAttrValue(ch,fe,AT_LAYERS,dir);
      chIncFeatureLine(ch,fe,0,eg,0);
      if( sordat )
        chSetAttrValue(ch,fe,SORDAT,sordat);
      nmark+=1;
    }
  }
  puts("One way:   "+num3+"   accepted: "+nacc+"   marked: "+nmark);
  ArFreeAll();
  chUpdatePresentation(ch);
  Redraw();
}
