/*         dcf   
         Street Center Line   Recording Indication
    2   .  -  ,  - .
      ANSI
*/

include <system.dh>
include <windows.dh>

const FE_STREET 60160
const FE_NOTURN 1666
const AT_ROADID 1711
const AT_RECIND 129
const AT_SCALVL 1703
const SCALVL_VAL "26"

local ArSearch(a,val)
{
  j=ArSize(a);
  i=1;
  while( i < j )
  {
    r=int((i+j)/2);
    c=ArGet(a,r);
    if( val > c )
      i=r+1;
    else if( val < c )
      j=r-1;
    else
      return r;
  }
  if( i == j && ArGet(a,i) == val )
    return i;
  return 0;
}

local DoneByBasil()
{
	if( !(ch=GetEditDataset()) )
		return;

	if( IDOK != OpenFileDlg(filename,"","",-1,"TXT files (*.txt)|*.txt|All files  (*.*)|*.*||") )
		return;
		
  ids=ArCreate(0);		
  egs=ArCreate(0);		
  for( fe=0; fe=chNextFeature(ch,fe); )
  {
    if( chGetFeatureCode(ch,fe) != FE_STREET || chGetMetricType(ch,fe) != M_LINE )
      continue;
    if( chGetAttrText(ch,fe,AT_ROADID,roadid) != 1 )
    {
	    puts( "*** street #"+fe+": no ROADID");
	    continue;
    }
    if( (num=chGetFeatureLine(ch,fe,0,edge,flag)) != 1 )
    {
	    puts( "*** street #"+fe+": "+num+" edges");
	    continue;
    }
    ArAdd(ids,int(roadid));
    ArAdd(egs,edge);
  }
  if( !(num=ArSize(egs)) )
  {
    ArFreeAll();
    puts("Nothing to do!");
    return 0;
  }
  ArSort(ids,egs);
  ArSort(ids,ids);
  for( i=num; i>1; i-=1 )
  {
    if( ArGet(ids,i) == ArGet(ids,i-1) )
    {
      puts("*** Duplicated ROADID "+ArGet(ids,i));
      ArFreeAll();
      return 0;
    } 
    //puts("<"+i+">"+ArGet(ids,i)+" "+ArGet(egs,i));     
  }
  
  if( !(fp=fopen(filename,"r")) )
  {
    puts("*** cannot open file "+filename);
    ArFreeAll();
    return;
  }

//puts(">>>");     
  total=tot=0;
	while( fgets(str,128,fp) )
	{
	  str=StrReplace(StrLTrim(StrRTrim(str)),"\t"," ");
	  if( !(k=StrFind(str," ")) )
	    continue;
	  total+=1;  
	  id1=int(str);  
	  id2=int(StrMid(str,k));  
    if( !(eg1=ArSearch(ids,id1)) )
    {
      puts("*** cannot find ROADID="+id1);
      continue;
    }
    if( !(eg2=ArSearch(ids,id2)) )
    {
      puts("*** cannot find ROADID="+id2);
      continue;
    }
    eg1=ArGet(egs,eg1);
    eg2=ArGet(egs,eg2);
    if( !chGetEdgeBegEnd(ch,eg1,b1,e1) )
    {
      puts("*** cannot find edge #"+eg1+" by ROADID="+id1);
      continue;
    }
    if( !chGetEdgeBegEnd(ch,eg2,b2,e2) )
    {
      puts("*** cannot find edge #"+eg2+" by ROADID="+id2);
      continue;
    }
    chGetNodeXY(ch,b1,bx1,by1);
    chGetNodeXY(ch,e1,ex1,ey1);
    chGetNodeXY(ch,b2,bx2,by2);
    chGetNodeXY(ch,e2,ex2,ey2);
    if( b1 == b2 || bx1 == bx2 && by1 == by2 )
    {
      flag1=M_REVERSE;
      flag2=0;
    }
    else if( b1 == e2 || bx1 == ex2 && by1 == ey2 )
    {
      flag1=M_REVERSE;
      flag2=M_REVERSE;
    }
    else if( e1 == e2 || ex1 == ex2 && ey1 == ey2 )
    {
      flag1=0;
      flag2=M_REVERSE;
    }
    else if( e1 == b2 || ex1 == bx2 && ey1 == by2 )
    {
      flag1=0;
      flag2=0;
    }
    else
    {
      puts("* warning: disconnected NoTurn on edges #"+eg1+" -> #"+eg2); 
      flag1=0;
      flag2=0;
    }
    if( !(fe=chCrtFeature(ch,FE_NOTURN)) )
    {
      puts("*** cannot add new feature");
	    continue;
    }
    chSetAttrText(ch,fe,AT_RECIND,str(id1)+" -> "+id2);
    chSetAttrText(ch,fe,AT_SCALVL,SCALVL_VAL);
    chIncFeatureLine(ch,fe,1,eg1,flag1);
    chIncFeatureLine(ch,fe,2,eg2,flag2);
    tot+=1;
	}
  fclose(fp);
  ArFreeAll();
  puts("Total NoTurn accepted: "+tot+" of "+total);
}

const OBJ_CODE_SREET		60160 //Street central line
const OBJ_CODE_SREET_2		1666  //no passage
const ATTR_CODE_ID			1711 //129 // 1711  //148
const ATTR_CODE_DIR			1703  //102
const ATTR_CODE_ID2			129//129   //148



local GetNextToken( str, pos, strDel, bEnd )
{
	strVal = "";
	pos = StrFind( str, strDel );
	if ( pos == 0 )
	{
		strVal = StrMid( str, pos+1 );
        bEnd = 1;
	}
	else
	{
		strVal = StrLeft( str, pos-1 );
        bEnd = 0;
	}
	str = StrMid( str, pos+1 );
	return strVal;
}


global main()
{
  return DoneByBasil();
  
	if( !(ch=GetEditDataset()) )
	{
		puts( "ERROR: Unable to load active chart" );
		return;
	}

	filename = "";
	if( OpenFileDlg( filename,"","",-1,"TXT files (*.txt)|*.txt|All files  (*.*)|*.*||") != IDOK )
	{
		puts( "ERROR: Input file not found" );
		return;
	}

	if ( !(file = fopen( filename, "r" )) )
	{
		puts( "ERROR: Unable to open file" );
		return;
	}

//	counter = 0;//!!
	while( fgets( str, 3200, file ) )
	{
//        counter += 1;//!!
//        if ( counter > 10 )//!!
//            break;//!!

		strVal = "";
		pos = 0;
        bEnd = 0;
/*        if ( !StrLen(GetNextToken(str, pos, "\t", bEnd)) )
            continue;
		pos += 1;
        if ( !StrLen(GetNextToken(str, pos, "\t", bEnd)) )
            continue;
		pos += 1;*/

		id1 = int(GetNextToken( str, pos, "\t", bEnd));
		pos += 1;

/*        if ( !StrLen(GetNextToken(str, pos, "\t", bEnd)) )
            continue;
		pos += 1;*/

        ArID2 = ArCreate( 0 );
        strID = GetNextToken( str, pos, "\t", bEnd );
        pos1 = 0;
        strID2 = StrReplace( GetNextToken(strID, pos1, "-", bEnd), "\"", "" );
        pos1 += 1;
        while ( !bEnd )
        {
            ArAdd( ArID2, int(strID2) );
            strID2 = GetNextToken( strID, pos1, "-", bEnd );
            pos1 += 1;
        }
        if ( StrLen(strID2) > 0 )
            ArAdd( ArID2, int(strID2) );
        
        if ( !ArSize(ArID2) )
        {
			puts( "ERROR: Unable get EdgeT ID-s" );
            ArFreeAll();
			continue;
        }

		edge1 = 0;
        ArEgde2 = ArCreate( 0 );
		for ( chObj = chNextFeature( ch, NULL ); chObj; chObj = chNextFeature( ch, chObj ) )
		{
			if ( (chGetFeatureCode(ch, chObj) != OBJ_CODE_SREET)
				||(chGetMetricType( ch, chObj ) != M_LINE) )
				continue;

			attrVal = "";
			chGetAttrText( ch, chObj, ATTR_CODE_ID, attrVal );
			if ( int(attrVal) == id1)
            {
			    edge = NULL;
			    flag = NULL;
			    if  ( chGetFeatureLine(ch, chObj, 0, edge, flag ) != 1 )
			    {
				    puts( "ERROR: Uncorrect street: line #" + str(chObj-1) );
				    continue;
			    }
				edge1 = edge;
				continue;
            }

            bAdd = 0;
            for ( i=0; i<ArSize(ArID2); i+=1 )
            {
                if ( ArGet(ArID2, i+1) == int(attrVal) )
                {
			        edge = NULL;
			        flag = NULL;
			        if  ( chGetFeatureLine(ch, chObj, 0, edge, flag ) != 1 )
			        {
				        puts( "ERROR: Uncorrect street: line #" + str(chObj-1) );
				        continue;
			        }
				    ArAdd( ArEgde2, edge );
                    bAdd = 1;
				    break;
                }
            }
            if ( bAdd )
                continue;

			if ( (edge1 != 0)
				&&(ArSize(ArEgde2) == ArSize(ArID2)) )
				break;
		}
		
		if ( (edge1 == 0)
			||(ArSize(ArEgde2) == 0) )
		{
            puts( "ERROR: Unable to find same id :" + str(id1) );
            ArFreeAll();
			continue;
		}

        for ( i=0; i<ArSize(ArEgde2); i+=1 )
        {
            if ( !(chOutObjStreet = chCrtFeature( ch, OBJ_CODE_SREET_2 )) )
		    {
			    puts( "ERROR: Unable to create street obj" );
                ArFreeAll();
			    continue;
		    }
		   // chSetAttrText( ch, chOutObjStreet, ATTR_CODE_DIR, "4" );
		    chSetAttrText( ch, chOutObjStreet, ATTR_CODE_ID2, str(id1) + " -> " + str(ArGet(ArEgde2, i+1)) );
			chSetAttrText( ch,chOutObjStreet,ATTR_CODE_DIR,"26");

            beg0 = NULL;
            end0 = NULL;
            chGetEdgeBegEnd( ch, edge1, beg0, end0 );
            beg1 = NULL;
            end1 = NULL;
            chGetEdgeBegEnd( ch, ArGet(ArEgde2, i+1), beg1, end1 );
            rev0 = 0;
            rev1 = 0;
            if ( beg0 == beg1 )
            {
                rev0 = M_REVERSE;
                rev1 = 0;
            }
            else if ( beg0 == end1 )
            {
                rev0 = M_REVERSE;
                rev1 = M_REVERSE;
            }
            else if ( end0 == beg1 )
            {
                rev0 = 0;
                rev1 = 0;
            }
            else if ( end0 == end1 )
            {
                rev0 = 0;
                rev1 = M_REVERSE;
            }

/*            puts( str(edge1) + " " + str(beg0) + " " + str(end0) );
            puts( str(ArGet(ArEgde2, i+1)) + " " + str(beg1) + " " + str(end1) );
            puts( str(rev0) + " " + str(rev1) );
            puts( "==================" );*/
		    chIncFeatureLine( ch, chOutObjStreet, 1, edge1, rev0 );
		    chIncFeatureLine( ch, chOutObjStreet, 2, ArGet(ArEgde2, i+1), rev1 );
        }

        ArFreeAll();
	}


//	CloseDataset( ch );
	fclose( file );
	puts( "Conversion successfully completed" );
}