//     No Passage,     nopass (L777777;F7777777)
//  ( nopass)        : L0  F0
//      Compact Chart

include <system.dh>
include <windows.dh>
include <LookUp2DInc.dh>

const FE_STREET 60160
const FE_NOTURN 1666

const AT_SCALVL 1703
const AT_ROADID 1711
const AT_NOPASS 1712

local ArSearch(a,val)
{
  j=ArSize(a);
  i=1;
  while( i < j )
  {
    r=int((i+j)/2);
    c=ArGet(a,r);
    if( val > c )
      i=r+1;
    else if( val < c )
      j=r-1;
    else
      return r;
  }
  if( i == j && ArGet(a,i) == val )
    return i;
  return 0;
}

local isEqualNodes(ch,n1,n2)
{
  //chGetNodeXY(ch,n1,x1,y1);
  //chGetNodeXY(ch,n2,x2,y2);
  //return( x1 == x2 && y1 == y2 );
  return( n1 == n2 );
}

local getNoTurnConnect(ch,fe1,fe2,dir,eg2)
{
  if( 1 != chGetFeatureLine(ch,fe1,1,eg1,null) || 1 != chGetFeatureLine(ch,fe2,1,eg2,null) )
    return 0;
  chGetEdgeBegEnd(ch,eg1,b1,e1);
  if( dir < 0 )
    nod=b1;
  else if( dir > 0 )
    nod=e1;
  else
    return 0;  
  chGetEdgeBegEnd(ch,eg2,b2,e2);
  if( isEqualNodes(ch,nod,b2) )
    return 1;
  if( isEqualNodes(ch,nod,e2) )
    return -1;
  return 0;  
}

local strtok(s,delim)
{
  s=StrMid(s,StrLen(StrSpanIn(s,delim))+1);
  tok=StrSpanEx(s,delim);
  s=StrMid(s,StrLen(tok)+1);
  return tok;
}

global main()
{
  if( !(ch=GetEditDataset()) )
    return;
  StartIndicator("Processing I...",chFeatureNum(ch)*3);
  maxid=0;
  num=0;
  news=ArCreate(0);
  nots=ArCreate(0);
  for( fe=0; fe=chNextFeature(ch,fe); )
  {
    StepIndicator();
    if( FE_NOTURN == (code=chGetFeatureCode(ch,fe)) )
    {
      if( 2 == chGetFeatureLine(ch,fe,1,eg1,flag) )
      {
        if( flag & M_REVERSE )
          eg1=-eg1;
        chGetFeatureLine(ch,fe,2,eg2,flag);  
        if( flag & M_REVERSE )
          eg2=-eg2;
        ArAdd(nots,""+eg1+" "+eg2);  
      }
      continue;
    }
    if( FE_STREET != code || !chGetAttrValue(ch,fe,AT_ROADID,id) || id <= 0 )
      continue;
    num+=1;
    if( maxid < id )
      maxid=id;  
  }
  id2fe=ArCreate(maxid);
  for( id=ArSize(id2fe); id; id-=1 )
    ArSetAt(id2fe,id,0);
  for( fe=0; fe=chNextFeature(ch,fe); )
  {
    StepIndicator();
    if( FE_STREET != chGetFeatureCode(ch,fe) || !chGetAttrValue(ch,fe,AT_ROADID,id) || id <= 0 )
      continue;
    ArSetAt(id2fe,id,fe);  
  } 
  
  tot=passed=lost=0;
  for( fe=0; fe=chNextFeature(ch,fe); )
  {
    StepIndicator();
    if( FE_STREET != chGetFeatureCode(ch,fe) || !chGetAttrText(ch,fe,AT_NOPASS,not) )
      continue;
    if( 1 != chGetFeatureLine(ch,fe,1,eg1,flag) )
    {
      lost+=1;
      puts("*** cannot get edge of Street #"+fe);
      continue;
    } 
    if( !chGetAttrValue(ch,fe,AT_SCALVL,scalvl) )
      scalvl=0;  
   // while( (tok=strtok(not,", ")) )
    while( (tok=strtok(not,"; ")) )
   
    {
     //if( (k=StrFind(tok,"F")) > 0 )
     if( (k=StrFind(tok,"L")) > 0 )
        dir1=-1;
     // else if( (k=StrFind(tok,"L")) > 0 )
      else if( (k=StrFind(tok,"F")) > 0 )
        dir1=1;
      else
      {
        lost+=1;
        puts("*** cannot get direction of Street #"+fe);
        continue;
      }
      id2=int(StrMid(tok,k+1));
      if( !(fe2=ArGet(id2fe,id2)) )
      {
        lost+=1;
        puts("*** cannot find RoadID="+id2+" (Street #"+fe+")");
        continue;
      }
      dir2=getNoTurnConnect(ch,fe,fe2,dir1,eg2);
      if( !dir2 )
      {
        lost+=1;
        puts("*** cannot connect Street #"+fe+" to Street #"+fe2);
        continue;
      }
      if( dir1 < 0 )  
        s="-"+eg1;
      else
        s=""+eg1;
      if( dir2 < 0 )
        s+=" -"+eg2;
      else
        s+=" "+eg2;  
      ArAdd(news,s);  
    }
  } 
  if( ArSize(news) )
  {
    ArSort(news,news);
    for( i=ArSize(news); i>1; i-=1 )
    {
      if( ArGet(news,i) == ArGet(news,i-1) )
      {
        ArRemoveAt(news,i);
        passed+=1;
      }
    }
    if( ArSize(nots) )
    {
      ArSort(nots,nots);
      for( i=ArSize(news); i; i-=1 )
      {
        if( ArSearch(nots,ArGet(news,i)) )
        {
          ArRemoveAt(news,i);
          passed+=1;
        }
      }
    } 
    for( StartIndicator("Processing II...",i=ArSize(news)); i; i-=1 )
    {
      StepIndicator();
      s=ArGet(news,i);
      eg1=int(s);
      eg2=int(StrMid(s,StrFind(s," ")+1));
      if( eg1 > 0 )
        dir1=0;
      else  
      {
        eg1=-eg1;
        dir1=M_REVERSE;
      }
      if( eg2 > 0 )
        dir2=0;
      else  
      {
        eg2=-eg2;
        dir2=M_REVERSE;
      }
      fe2=chCrtFeature(ch,FE_NOTURN);  
      chSetAttrText(ch,fe2,SORIND,""+fe2);
      chIncFeatureLine(ch,fe2,1,eg1,dir1);  
      chIncFeatureLine(ch,fe2,2,eg2,dir2);  
      tot+=1;
    }
  }
  ArFree(id2fe);
  ArFree(nots);
  ArFree(news);
  FinishIndicator();
  puts("Total new: "+tot+"  passed: "+passed+"  lost: "+lost);
  chUpdatePresentation(ch);
  Redraw();
}
