include <windows.dh>
include <system.dh>
include <LookUp2DInc.dh>

const FE_STREET 60160
const FE_FERYRT 60770
const AT_SCALVL 1703
const AT_ROACLS 17508
const AT_STRNAM 60030

local egs 0
local frt 0
local ch 0
local cnt 0
local scaLvl 0

local isLinePC(ch,fe)
{
  return( chGetFeatureCode(ch,fe) == FE_LINE &&
          chGetAttrValue(ch,fe,AT_LAYERS,layer) && layer >= 1 && layer <= 3 );
}

local isLineCP(ch,fe)
{
  return( chGetMetricType(ch,fe) == M_LINE &&
          ( (code=chGetFeatureCode(ch,fe)) == FE_STREET || code == FE_FERYRT ) &&    
          chGetAttrValue(ch,fe,AT_SCALVL,scalvl) && scalvl == scaLvl &&
          ( chGetAttrText(ch,fe,AT_STRNAM,strnam) || !chGetAttrValue(ch,fe,AT_ROACLS,roacls) || roacls != 5 && roacls != 14 ) ); // noname yards & path
}

local findIn(a,v)
{
  for( i=ArSize(a); i && v!=ArGet(a,i); i-=1 );
  return i;
}

local front()
{
  nd=ArGet(frt,1);
  if( !(es=chGetEdgesOfNode(ch,nd)) )
  {
    ArRemoveAt(frt,1);
    return;
  }
  for( i=ArSize(es); i; i-=1 )
  {
    eg=ArGet(es,i);
    if( !(j=findIn(egs,eg)) )
      continue;
    chGetEdgeBegEnd(ch,eg,beg,end);
    if( beg != nd && !findIn(frt,beg) )
    {
      ArAdd(frt,beg);
      //chHighlightNode(ch,beg);
    }
    if( end != nd && !findIn(frt,end) )
    {
      ArAdd(frt,end);
      //chHighlightNode(ch,end);
    }
    ArRemoveAt(egs,j);
    //chHighlightEdge(ch,eg);
    //if( !((cnt+=1)%100) )
    //  puts(""+ArSize(egs)+" "+ArSize(frt));
  }
  ArFree(es);
  ArRemoveAt(frt,1);
  //chHighlightNode(ch,nd);
} 

local findFast(a,key)
{
  if( !(last=ArSize(a)) )
    return -1;
  frst=1;
  for( ; ; )
  {
    cur=int((frst+last)/2);
    v=ArGet(a,cur);
//puts("key="+key+" "+v+"["+cur+"]  "+frst+"-"+last);    
    if( key > v )
    {
      frst=cur;
      r=1;
    }  
    else if( key < v )
    {
      last=cur;
      r=-1;
    }  
    else
      return cur;
    d=last-frst;
//puts(">>>>>>>"+d);    
    if( d == 1 )
    { 
      if( r < 0 )
        cur=frst;
      else
        cur=last;     
      v=ArGet(a,cur);
      if( key > v )
        return -(cur+1);  
      if( key < v )
        return -cur;
      return cur;
    }
    else if( !d )
    {
      if( ArGet(a,frst) < key )
        frst+=1;
      return -frst;
    }  
  }
}

/*local exiter(s)
{
  puts(s);
  ArFreeAll();
  exit(0);
}

local chkSort(a)
{
  sz=ArSize(a);
  for( i=2; i<=sz; i+=1 )
    if( ArGet(a,i-1) > ArGet(a,i) )
      return 1;
  return 0;    
}*/

local frontFast()
{
  nd=ArGet(frt,1);
  ArRemoveAt(frt,1);
  if( !(es=chGetEdgesOfNode(ch,nd)) )
    return;
  for( i=ArSize(es); i; i-=1 )
  {
    eg=ArGet(es,i);
    if( (j=findFast(egs,eg)) <= 0 )
      continue;
    ArRemoveAt(egs,j);
    chGetEdgeBegEnd(ch,eg,beg,end);
    if( beg != nd && (n=findFast(frt,beg)) < 0 )
    {
      /*puts("1>"+n+" "+beg);
      s="2>";
      for( j=1; j<=ArSize(frt); j+=1 ) s+=" "+ArGet(frt,j);
      puts(s);*/
      n=-n;
      if( n <= ArSize(frt) )
        ArInsertAt(frt,n,beg);  
      else  
        ArAdd(frt,beg);
      //if( chkSort(frt) ) 
      //  exiter("4");
    }
    if( end != nd && (n=findFast(frt,end)) < 0 )
    {
      /*puts("1>"+n+" "+end);
      s="2>";
      for( j=1; j<=ArSize(frt); j+=1 ) s+=" "+ArGet(frt,j);
      puts(s);*/
      n=-n;
      if( n <= ArSize(frt) )
        ArInsertAt(frt,n,end);  
      else  
        ArAdd(frt,end);
      //if( chkSort(frt) ) 
      //  exiter("5");
    }
  }
  //puts(">>"+ArSize(frt));
  ArFree(es);
} 

global main()
{
  if( !(ch=GetEditDataset()) )
    return;
  //if( IDNO == MessageBox("   Compact    :\nTools -> Compact Chart\nMerge identical attributes = No\n\n  ?",MB_ICONINFORMATION|MB_YESNO) )
  //  return;
  if( !(fe=chNextFeature(ch,0)) )
    return;
  
  ds=chGetFeatureDictionary(ch,fe);
  if( ds == 1650 )
    isPC=1;
  else if( ds == 64003 )
  {
    isPC=0;
    for( fe=0; fe=chNextFeature(ch,fe); )
    {
      if( chGetMetricType(ch,fe) == M_LINE &&
          chGetFeatureCode(ch,fe) == 60160 && // STREET
          chGetAttrValue(ch,fe,1703,scalvl) && scalvl > scaLvl )
        scaLvl=scalvl;
    }
  }
  else
    return;    
  if( isPC )  
    chCompact(ch,0);
  //ArFreeAll();
  egs=ArCreate(0);
  frt=ArCreate(0);
  for( fe=0; fe=chNextFeature(ch,fe); )
  {
    if( isPC )
      is=isLinePC(ch,fe);
    else
      is=isLineCP(ch,fe);  
    if( is )
    {
      if( chGetAttrText(ch,fe,SORDAT,sordat) )
      {
        MessageBox("    SORDAT",MB_OK|MB_ICONSTOP);
        ArFreeAll();
        return; 
      }
      sz=chGetFeatureLine(ch,fe,1,eg,flag);
      ArAdd(egs,eg);
      for( i=2; i<=sz; i+=1 )
      {
        chGetFeatureLine(ch,fe,i,eg,flag);
        ArAdd(egs,eg);
      }
    }
  }
  ArSort(egs,egs);
  chGetEdgeBegEnd(ch,ArGet(egs,1),beg,end);
//puts("started node #"+beg);  
  ArAdd(frt,beg);
  while( (k=ArSize(frt)) )
  {
    //front();
    frontFast();
  }  
  //puts(" : "+ArSize(egs));
  chHighlightOff(ch);
  tot=0;
  for( i=ArSize(egs); i; i-=1 )
  {
    if( !(fes=chGetFeaturesOfEdge(ch,eg=ArGet(egs,i))) )
    {
      puts("***"+eg);
      chHighlightEdge(ch,eg);
    }
    r=0;
    for( j=ArSize(fes); j; j-=1 )
    {
      fe=ArGet(fes,j);
      if( isPC )
        is=isLinePC(ch,fe);
      else
        is=isLineCP(ch,fe);  
      if( is )
      {
        if( !chGetAttrValue(ch,fe,SORDAT,sordat) )
        {
          chSetAttrValue(ch,fe,SORDAT,20000101);
          tot+=1;
        }
        r+=1;
      }
    }
    ArFree(fes);
    if( r > 1 )
      puts("*** shared edge "+eg);
    else if( !r )
    {
      puts("***"+eg);
      chHighlightEdge(ch,eg);
    }
  }
  ArFree(egs);
  ArFree(frt);
  rep=ArReport();
  if( rep )
  {
    puts(rep);
    ArFreeAll();
  }  
  if( tot )
    MessageBox(" SORDAT: "+tot,MB_OK|MB_ICONINFORMATION);
  else
    MessageBox("   ",MB_OK|MB_ICONINFORMATION);
}
