include <system.dh>
include <windows.dh>
include <LookUp2DInc.dh>

const FE_STREET 60160
const AT_SCALVL 1703

local isPC 0

global main()
{
  if( !(ch=GetEditDataset()) )
    return;
  if( !(fe=chNextFeature(ch,0)) )
    return;
  ds=chGetFeatureDictionary(ch,fe);
  if( ds == 1650 )
    isPC=1;
  else if( ds != 64003 )
    return;
  show=1;
  tot=0;
  chSetGeoUnits(1);
  if( isPC )
  {
    StartIndicator("Processing...",chEdgeNum(ch));
    for( eg=0; eg=chNextEdge(ch,eg); )
    {
      StepIndicator();
      if( !(fes=chGetFeaturesOfEdge(ch,eg)) )
        continue;
      n=0;
      for( i=ArSize(fes); i; i-=1 )
      {
        fe=ArGet(fes,i);
        //if( chGetAttrValue(ch,fe,AT_WIDTH,wid) && wid == 10 )
        //  continue;
        //if( chGetAttrValue(ch,fe,AT_SHIFTX,shift) && shift > 0 )
        //  continue;
        if( !chGetAttrValue(ch,fe,AT_LAYERS,layer) || layer < 1 || layer > 3 )
          continue;
        n+=1;
      }
      if( n > 1 )
      { 
        tot+=1;
        //QueryFeature(ArGet(fes,1));
        if( show )
        {
          show=0;
          chOverviewEdge(ch,eg);
          chHighlightEdge(ch,eg);
        }
        //ArFree(fes);
        //return;
      } 
      ArFree(fes);
    }
  }
  else // CP
  {
    scalvls=-1;
    for( fe=0; fe=chNextFeature(ch,fe); )
    {
      if( chGetFeatureCode(ch,fe) == FE_STREET )
      {
        if( !chGetAttrValue(ch,fe,AT_SCALVL,scalvl) ) 
          scalvl=0;
        if( scalvls < 0 )
          scalvls=scalvl;
        else if( scalvl != scalvls )
          break;  
      }
    }
    if( fe )
    {
      if( IDYES == MessageBox("Compact mutilayer chart before testing?",MB_ICONQUESTION|MB_YESNO) )
        chCompact(ch,0);
    }  
    StartIndicator("Processing...",chEdgeNum(ch));
    idx=ArCreate(50);
    for( i=ArSize(idx); i; i-=1 )
      ArSetAt(idx,i,0);
    for( eg=0; eg=chNextEdge(ch,eg); )
    {
      StepIndicator();
      if( !(fes=chGetFeaturesOfEdge(ch,eg)) )
        continue;
      n=0;
      for( i=ArSize(fes); i; i-=1 )
      {
        fe=ArGet(fes,i);
        if( chGetFeatureCode(ch,fe) != FE_STREET )
          continue;
        if( !chGetAttrValue(ch,fe,AT_SCALVL,scalvl) ) 
          scalvl=50;
        ArSetAt(idx,scalvl,ArGet(idx,scalvl)+1);  
        n+=1;
      }
      if( n )
      { 
        for( i=ArSize(idx); i; i-=1 )
        {
          j=ArGet(idx,i);
          if( j > 1 )
          {
            if( show )
            {
              show=0;
              chOverviewEdge(ch,eg);
              chHighlightEdge(ch,eg);
            }
            chGetEdgeXY(ch,eg,0,lat1,lon1);
            chGetEdgeXY(ch,eg,1,lat2,lon2);
            lat=(lat1+lat2)*0.5;
            lon=(lon1+lon2)*0.5;
            if( lat < 0 )
              coordstr=printf("S%.5lf",-lat);
            else  
              coordstr=printf("N%.5lf",lat);
            if( lon < 0 )  
              coordstr+=printf(" : W%.5lf",-lon);
            else
              coordstr+=printf(" : E%.5lf",lon);
            tot+=1;
            if( i == 50 )
              puts("edge #"+eg+" shared -- "+coordstr);
            else  
              puts("edge #"+eg+" shared at scale level "+i+" -- "+coordstr);
          }
          if( j )
            ArSetAt(idx,i,0);
        }  
      }
      ArFree(fes);
    }
    ArFree(idx);
  }  
  FinishIndicator();
  puts("Total: "+tot);
}
