include <LookUp2DInc.dh>
include <system.dh>
include <windows.dh>

const ignore02 1
const ignoreSlash 0

const codepage 0

local error(err)
{
  ArFreeAll();
  puts("****************************************************");
  puts("");
  puts("*** error "+err);
  MessageBox(err,MB_ICONSTOP|MB_OK);
  exit(0);
}

local wide2char(c)
{
  if( c < 256 )
    return c;
  if( c >= 0x410 && c <= 0x44F )
    return c-0x350; // 0x410-0xC0;
  if( c == 0x401 ) // 
    return 0xA8;
  if( c == 0x451 ) // 
    return 0xB8;
  if( c == 0x404 ) // 
    return 0xAA;
  if( c == 0x407 ) //  
    return 0xAF;
  if( c == 0x406 ) // 
    return 0xB2;
  if( c == 0x454 ) //  
    return 0xBA;
  if( c == 0x457 ) // 
    return 0xBF;
  if( c == 0x456 ) // 
    return 0xB3;
  if( c == 0x2116 ) // 
    return 0xB9;
  return 0;  
}

local SelectDataset()
{
  init="";
  arr=ArCreate(0);
  ch=0;
  while( (ch=NextDataset(ch)) )
  {
    if( ch == GetEditDataset() )
      continue;
    if( chGetProperty(ch,CH_NAME,name) && chGetProperty(ch,CH_DICT1,ds) )
    {
      if( ds != 1650 && ds != 60020 )
        continue;
      init+="|"+name;
      ArAdd(arr,ch);
    }
  }
  if( !(i=ArSize(arr)) )
  {
    ArFree(arr);
    return 0;
  }
  if( i == 1 )
  {
    ch=ArGet(arr,1);
    ArFree(arr);
    return ch;
  }
  if( !(ret=ListDlg("Select InfRouter",StrMid(init,2))) )
  {
    ArFree(arr);
    return 0;
  }
  ch=ArGet(arr,ret);
  ArFree(arr);
  return ch;
}

global makeAddressFile()
{
  if( !(ch=GetEditDataset()) || !(inf=SelectDataset()) )
    return 0;
  chSetGeoUnits(1);  
  nam=ArCreate(0);  
  val=ArCreate(0);
  len=ArCreate(0);
  for( fe=0; fe=chNextFeature(ch,fe); )
  {
    if( chGetFeatureCode(ch,fe) == FE_SYMBOL &&
        chGetAttrText(ch,fe,STRNAM,strnam) &&
        chGetAttrText(ch,fe,NUMBER,number) )
    {
      if( ignore02 && chGetAttrText(ch,fe,AT_NAME,fntnam) && fntnam != "circle01" )
        continue; 
      if( ignoreSlash && (i=StrFind(number,"/")) )
        number=StrLeft(number,i-1);
      while( StrFind(number,":") )
        number=StrReplace(number,":",";");
      if( !chGetFeatureNode(ch,fe,nd) )
        error(2);
      chGetNodeXY(ch,nd,lat,lon);
      sz=StrLen(number)+9;
      number+=printf(":%.7g",deg2rad(lat))+printf(":%.7g",deg2rad(lon));  
      for( i=ArSize(nam); i; i-=1 )
        if( ArGet(nam,i) == strnam )
          break;
      if( i )
      {
        ArSetAt(val,i,ArGet(val,i)+"|"+number);
        ArSetAt(len,i,ArGet(len,i)+sz);
      }
      else
      {
        ArAdd(nam,strnam);
        ArAdd(val,number);
        ArAdd(len,sz);
      }    
    } 
  }
  sft=ArCreate(0);
  ArAdd(sft,0);  
  for( i=2; i<=ArSize(len); i+=1 )
    ArAdd(sft,ArGet(sft,i-1)+ArGet(len,i-1));
  chGetProperty(ch,CH_NAME,filename);
  for( i=ArSize(nam); i; i-=1 )
  {
    name=ArGet(nam,i);
    for( fe=0; fe=chNextFeature(inf,fe); )
    {
      if( chGetFeatureCode(inf,fe) == FE_LINE &&
          chGetAttrText(inf,fe,SORIND,sorind) &&
          ( sorind == "#" || sorind == "" || sorind == "street" ) &&
          chGetAttrText(inf,fe,INFORM,strnam) && !StrICmp(strnam,name) )
        break;
    }
    if( !fe )//&& !StrFind(name," (") )  
      puts("*** no street: "+name);
  }
  tot=0;
  for( fe=0; fe=chNextFeature(inf,fe); )
  {
    if( chGetFeatureCode(inf,fe) == FE_LINE &&
        chGetAttrText(inf,fe,SORIND,sorind) &&
        ( sorind == "#" || sorind == "" || sorind == "street" ) &&
        chGetAttrText(inf,fe,INFORM,strnam) )
    {
      for( i=ArSize(nam); i && StrICmp(ArGet(nam,i),strnam); i-=1 );
      if( i )
        tot+=1;
    }  
  }
  if( (fp=fopen(filename+".address","wb")) )
  {
    fwrite(int2(0x370),fp);
    fwrite(int(tot),fp);
    written=0;
    for( fe=0; fe=chNextFeature(inf,fe); )
    {
      if( chGetFeatureCode(inf,fe) == FE_LINE &&
          chGetAttrText(inf,fe,SORIND,sorind) &&
          ( sorind == "#" || sorind == "" || sorind == "street" ) &&
          chGetAttrText(inf,fe,INFORM,strnam) )
      {    
        for( i=ArSize(nam); i && StrICmp(ArGet(nam,i),strnam); i-=1 );
        if( i )
        {
//puts(strnam+" + "+int(fe)+" + "+int(ArGet(sft,i))+" + "+int(ArGet(len,i)));      
          fwrite(int(fe),fp);
          fwrite(int(ArGet(sft,i)),fp);  
          fwrite(int(ArGet(len,i)),fp);
          written+=1;
        }  
      }
    }
    if( written != tot )
      puts("!!! actual number of tegs is "+written+" instead of "+tot);
    for( i=1; i<=ArSize(val); i+=1 )
    {
      str=ArGet(val,i);
//puts(str);      
//dbg="";
      written=0;
      while( (j=StrFind(str,":")) )
      {
        //if( (k=StrFind(ss=StrCharset(StrLeft(str,j-1),1252),"|")) )
        if( (k=StrFind(ss=StrLeft(str,j-1),"|")) )
          ss=StrMid(ss,k+1);
        str=StrMid(str,j+1);
        fwrite(lat=real4(str),fp);
        j=StrFind(str,":");
        str=StrMid(str,j+1);
        fwrite(lon=real4(str),fp);
//dbg+="|"+ss+":"+str(lat)+":"+str(lon);        
        sz=StrLen(ss);
        for( j=1; j<=sz; j+=1 )
        {
          if( !(c=wide2char(StrChar(ss,j))) )
          {
            sss=StrWide2Char(StrMid(ss,j,1),codepage);
            if( (c=StrChar(sss,1)) > 255 )
            {
              fclose(fp);
              error("unexpected symbol '"+StrMid(ss,j,1)+printf("' (0x%X)",StrChar(ss,j)));
            }
            puts("!!! symbol '"+StrMid(ss,j,1)+printf("' (0x%X)",StrChar(ss,j))+" -> '"+StrLeft(sss,1)+printf("' (0x%X)",StrChar(sss,1)));
          }
          if( c > 127 )
            c-=256;
          fwrite(int1(c),fp);
        }
        fwrite(int1(0),fp);
        written+=sz+9;
      };
      if( written != ArGet(len,i) )
        puts("!!! "+ArGet(nam,i)+" - actual bytes "+written+" instead of "+ArGet(len,i));
//puts(dbg);
//puts("");      
    }
    fclose(fp);
  }  
  ArFreeAll();
  return 1;
}

global main()
{
  if( MessageBox("   (  )  InfRouter",MB_ICONINFORMATION|MB_OKCANCEL) == IDCANCEL )
    return;
  if( !makeAddressFile() )
    return;  
  //chUpdatePresentation(ch);
  Redraw();
  if( (ch=GetEditDataset()) )
  {
    chGetProperty(ch,CH_NAME,filename);
    MessageBox("  "+filename+".address",MB_ICONINFORMATION|MB_OK);
  }  
}
